'From Squeak 2.0 BETA of May 8, 1998 on 15 May 1998 at 8:02:39 pm'!

!ClassOrganizer methodsFor: 'fileIn/Out'!
fileOutCommentOn: aFileStream moveSource: moveSource toFile: fileIndex
	"Copy the class comment to aFileStream.  If moveSource is true (as in compressChanges or compressSources, then update globalComment to point to the new file."
	| fileComment |
	globalComment ifNotNil: 
			[aFileStream cr.
			fileComment _ RemoteString newString: globalComment text
							onFileNumber: fileIndex toFile: aFileStream.
			moveSource ifTrue: [globalComment _ fileComment]]! !

!ClassOrganizer methodsFor: 'fileIn/Out'!
moveChangedCommentToFile: aFileStream numbered: fileIndex 
	"If the comment is in the changes file, then move it to a new file."

	(globalComment ~~ nil and: [globalComment sourceFileNumber > 1]) ifTrue: 
		[self fileOutCommentOn: aFileStream moveSource: true toFile: fileIndex]! !

!ClassOrganizer methodsFor: 'fileIn/Out'!
putCommentOnFile: aFileStream numbered: sourceIndex moveSource: moveSource forClass: aClass
	"Store the comment about the class onto file, aFileStream."
	| header |
	globalComment ifNotNil:
		[aFileStream cr; nextPut: $!!.
		header _ String streamContents: [:strm | 
				strm nextPutAll: aClass name;
				nextPutAll: ' commentStamp: '.
				Utilities changeStamp storeOn: strm.
				strm nextPutAll: ' prior: '; nextPutAll: '0'].
		aFileStream nextChunkPut: header.
		aClass organization fileOutCommentOn: aFileStream
				moveSource: moveSource toFile: sourceIndex.
		aFileStream cr]! !


!Metaclass methodsFor: 'fileIn/Out'!
fileOutOn: aFileStream moveSource: moveSource toFile: fileIndex
	super fileOutOn: aFileStream
		moveSource: moveSource
		toFile: fileIndex.
	(moveSource not and: [methodDict includesKey: #initialize]) ifTrue: 
		[aFileStream cr.
		aFileStream cr.
		aFileStream nextChunkPut: thisClass name , ' initialize'.
		aFileStream cr]! !

!Metaclass methodsFor: 'fileIn/Out'!
nonTrivial 
	"Answer whether the receiver has any methods or instance variables."

	^ self instVarNames size > 0 or: [methodDict size > 0]! !


