'From Squeak 2.0 BETA of May 8, 1998 on 15 May 1998 at 11:44:18 pm'!
MorphicModel subclass: #SystemWindow
	instanceVariableNames: 'labelString stripes label closeBox collapseBox activeOnlyOnTop '
	classVariableNames: 'TopWindow '
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!Color methodsFor: 'transformations' stamp: 'di 5/15/1998 21:54'!
dansDarker
	"Return a darker shade of the same color.
	An attempt to do better than the current darker method."
	^ Color h: self hue s: self saturation
		v: (self brightness - 0.16 max: 0.0)! !


!HandMorph methodsFor: 'meta menu' stamp: 'di 5/15/1998 23:22'!
buildWorldMenu
	"Build the meta menu for the world."
	| menu subMenu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	Project current isTopProject ifFalse:
		[menu add: 'exit this world' action: #exitWorld.
		menu addLine].
	menu add: 'paste morph' action: #pasteMorph.
	menu add: 'new morph...' action: #newMorph.

	World ifNotNil: [
		subMenu _ MenuMorph new defaultTarget: self.
		subMenu add: 'workspace' action: #openWorkspace.
		subMenu add: 'browser' action: #openBrowser.
		subMenu add: 'recent changes' action: #openRecentChanges.
		subMenu add: 'change sorter' action: #openChangeSorter.
		subMenu add: 'changes log' action: #openChangesLog.
		subMenu add: 'file list' action: #openFileList.
		subMenu add: 'transcript' action: #openTranscript.
		subMenu add: 'project (mvc)' action: #openMVCProject.
		subMenu add: 'project (morphic)' action: #openMorphicProject.
		subMenu add: 'project link...' action: #projectThumbnail.
"coming soon...
		subMenu addLine.
		subMenu add: 'collapse all' action: #collapseAll.
		subMenu add: 'expand all' action: #expandAll.
		subMenu add: 'find window' action: #findWindow.
"
		menu add: 'windows...' subMenu: subMenu].

	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'grab drawing from screen' action: #grabDrawingFromScreen.
	subMenu add: 'read drawing from file' action: #importImageFromDisk.
	subMenu add: 'make new drawing' target: self presenter associatedMorph action: #makeNewDrawingWithin.
	menu add: 'graphics...' subMenu: subMenu.

	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'add slot to model' action: #newVariable.
	subMenu add: 'write init method for model' action: #writeInitMethodForModel.
	subMenu add: 'grab model for this world' action: #grabModel.
	menu add: 'model...' subMenu: subMenu.

	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'set display depth...' action: #setDisplayDepth.
	subMenu add: 'change background color' action: #changeBackgroundColor.
	subMenu add: 'use texture background' target: self world action: #setStandardTexture.
	subMenu add: 'unlock contents' action: #unlockWorldContents.
	subMenu add: 'unhide hidden objects' action: #showHiders.
	subMenu add: 'round up stray objects' action: #roundUpStrayObjects.
	gridOn
		ifTrue: [subMenu add: 'turn gridding off' action: #setGridding]
		ifFalse: [subMenu add: 'turn gridding on' action: #setGridding].
	menu add: 'options...' subMenu: subMenu.

	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'update code from server' action: #updateFromServer.
	subMenu addLine.
	subMenu add: 'local host address' action: #reportLocalAddress.
	subMenu add: 'connect remote user' action: #connectRemoteUser.
	subMenu add: 'disconnect remote user' action: #disconnectRemoteUser.
	subMenu add: 'disconnect all remote users' action: #disconnectAllRemoteUsers.
	menu add: 'remote...' subMenu: subMenu.

	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'read drawing from file' action: #importImageFromDisk.
	subMenu add: 'save world in file' action: #saveWorldInFile.
	subMenu add: 'read morph(s) from file' action: #readMorphFile.
	menu add: 'file...' subMenu: subMenu.

	subMenu _ MenuMorph new defaultTarget: self world.
	subMenu add: 'add stop, step, & go buttons' target: self world presenter action: #addStopStepGoButtons.
	subMenu add: 'add scripting knobs' target: self presenter action: #addStandardControls.
	subMenu add: 'remove scripting knobs' target: self world action: #removeScriptingControls.
	subMenu addLine.
	subMenu add: 'parts bin' target: self presenter action: #createStandardPartsBin.
	subMenu add: 'control panel' target: self presenter action: #createControlPanel.
	menu add: 'scripting...' subMenu: subMenu.

	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'inspect world' action: #inspectWorld.
	subMenu add: 'inspect model' action: #inspectWorldModel.
	subMenu add: 'clear palette area' action: #clearPaletteArea.
	subMenu add: 'flush viewer cache' action: #flushViewerCache.
	subMenu add: 'full screen' action: #fullScreen.
	subMenu add: 'start MessageTally' action: #startMessageTally.
	subMenu add: 'call #tempCommand' action: #callTempCommand.
	subMenu add: 'show space left' action: #showSpaceLeft.
	menu add: 'debug...' subMenu: subMenu.

	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'save' action: #saveSession.
	subMenu add: 'save as...' action: #saveAs.
	subMenu add: 'save and quit' action: #saveAndQuit.
	subMenu add: 'quit...' action: #quitSession.
	menu add: 'save / quit...' subMenu: subMenu.

	^ menu! !

!HandMorph methodsFor: 'meta menu' stamp: 'di 5/15/1998 23:16'!
showSpaceLeft
	self inform: (Smalltalk bytesLeft asStringWithCommas, ' bytes available').
! !

!HandMorph methodsFor: 'meta menu' stamp: 'di 5/15/1998 23:19'!
updateFromServer
	Utilities absorbUpdatesWriteFiles: false zapNums: false! !


!ProjectViewMorph methodsFor: 'all' stamp: 'di 5/15/1998 22:49'!
drawOn: aCanvas

	(project ~~ nil and: [project thumbnail ~~ lastProjectThumbnail]) ifTrue:
			["scale thumbnail to fit my bounds"
			(WarpBlt toForm: image)
				sourceForm: project thumbnail;
				cellSize: 2;  "installs a colormap"
				combinationRule: Form over;
				copyQuad: (project thumbnail boundingBox) innerCorners
				toRect: (0@0 extent: image extent).
			lastProjectThumbnail _ project thumbnail.
			image borderWidth: 1].
	super drawOn: aCanvas.
! !


!StandardSystemView methodsFor: 'displaying' stamp: 'di 5/15/1998 21:55'!
displayLabelBackground: emphasized
	"Clear or emphasize the inner region of the label"
	| r1 r2 r3 c3 c2 c1 |
	emphasized ifFalse:
		["Just clear the label if not emphasized"
		^ Display fill: (self labelDisplayBox insetBy: 2) fillColor: self labelColor].
	r1 _ self labelDisplayBox insetBy: 2.
	r2 _ r1 insetBy: 0@2.
	r3 _ r2 insetBy: 0@3.
	c3 _ self labelColor.
	c2 _ c3 dansDarker.
	c1 _ c2 dansDarker.
	Display fill: r1 fillColor: c1.
	Display fill: r2 fillColor: c2.
	Display fill: r3 fillColor: c3.
 
"	Here is the Mac racing stripe code
	stripes _ Bitmap with: (self labelColor pixelWordForDepth: Display depth)
					with: (Form black pixelWordForDepth: Display depth).
	self windowOrigin y even ifTrue: [stripes swap: 1 with: 2].
	Display fill: (self labelDisplayBox insetBy: 3) fillColor: stripes.
"! !


!SystemWindow methodsFor: 'initialization' stamp: 'di 5/15/1998 22:18'!
addMorph: aMorph frame: relFrame
	| panelRect |
	self addMorph: aMorph.
	panelRect _ self panelRect.
	aMorph borderWidth: 1;
		bounds: ((relFrame scaleBy: panelRect extent) translateBy: panelRect topLeft).
	aMorph	color: (Color perform: model defaultBackgroundColor).
! !

!SystemWindow methodsFor: 'initialization' stamp: 'di 5/15/1998 23:40'!
extent: newExtent
	| inner panelRect paneFrames labelRect paneColor |
	panelRect _ self panelRect.
	paneFrames _ self paneMorphs collect:
		[:m | (m bounds translateBy: panelRect topLeft negated)
				scaleBy: (1.0/panelRect width)@(1.0/panelRect height)].
	super extent: newExtent.
	paneColor _ Color perform: model defaultBackgroundColor.
	self paneMorphs do: [:m | m color: paneColor].
	inner _ self innerBounds.
	labelRect _ inner withHeight: self labelHeight.
	stripes ifNotNil:  "backwd compat"
		[stripes first bounds: (labelRect insetBy: 1).
		stripes second bounds: (labelRect insetBy: 3).
		stripes second color: paneColor;
				borderColor: stripes second color darker.
		stripes first color: stripes second borderColor darker;
				borderColor: stripes first color darker].
	closeBox align: closeBox topLeft with: inner topLeft + (4@0).
	collapseBox align: collapseBox topRight with: inner topRight - (4@0).
	label align: label bounds topCenter with: inner topCenter.
	panelRect _ self panelRect.
	self paneMorphs with: paneFrames do:
		[:m :frame | m bounds: (((frame scaleBy: panelRect extent) translateBy: panelRect topLeft))]! !

!SystemWindow methodsFor: 'initialization' stamp: 'di 5/15/1998 23:39'!
initialize
	| aFont |
	super initialize.
	borderColor _ #raised.
	borderWidth _ 1.
	color _ Color black.
	aFont _ Preferences fontForScriptorButtons.
	stripes _ Array with: (RectangleMorph newBounds: bounds)  "see extent:"
				with: (RectangleMorph newBounds: bounds).
	self addMorph: (stripes first borderWidth: 1).
	self addMorph: (stripes second borderWidth: 2).
	self addMorph: (label _ StringMorph new contents: labelString;
			font: ((TextStyle default fontAt: 2) emphasized: 1)).
	self addMorph: (closeBox _ SimpleButtonMorph new borderWidth: 0;
			label: 'X' font: aFont; color: Color transparent;
			actionSelector: #delete; target: self; extent: 16@16).
	self addMorph: (collapseBox _ SimpleButtonMorph new borderWidth: 0;
			label: 'O' font: aFont; color: Color transparent;
			actionSelector: #collapse; target: self; extent: 16@16).
	self extent: 300@200! !

!SystemWindow methodsFor: 'panes' stamp: 'di 5/15/1998 22:26'!
paneColor: aColor
	self paneMorphs do: [:m | m color: aColor].
! !

!SystemWindow methodsFor: 'panes' stamp: 'di 5/15/1998 22:28'!
paneMorphs
	stripes ifNil: [^ submorphs copyFrom: 1 to: submorphs size-3  "old"].
	^ submorphs copyFrom: 1 to: submorphs size-5! !

!SystemWindow methodsFor: 'panes' stamp: 'di 5/15/1998 13:32'!
panelRect
	"Return the area below title bar, devoted to panes"
	^self innerBounds topLeft + (0@(self labelHeight))
					corner: self innerBounds bottomRight! !


Morph removeSelector: #paneColor:!
ScrollPane removeSelector: #paneColor:!
SystemWindow removeSelector: #initPanes!
