'From Squeak 2.0 of May 22, 1998 on 14 June 1998 at 12:12:29 pm'!
"Change Set:		ChangeSorterTweaks-di
Date:			14 June 1998
Author:			Dan Ingalls

A few tweaks to make the new ChangeSorter format work better...
	Update list after new, rename, remove.
	Present show... menu with most recent first, as in the list pane.
"!


!ChangeSorter methodsFor: 'changeSet menu' stamp: 'di 6/14/1998 12:07'!
chooseCngSet
	"Put up a list of them"
	| index |
	self okToChange ifFalse: [^ self].
	ChangeSet instanceCount > AllChangeSets size ifTrue: [self class gatherChangeSets].
	index _ (PopUpMenu labels: 
		(AllChangeSets reversed collect: [:each | each name]) asStringWithCr) startUp.
	index = 0 ifFalse: [self showChangeSet: (AllChangeSets at: index)].! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'di 6/14/1998 12:05'!
newSet
	"Create a new changeSet and show it.  make the new guy the current one.  Also, reject name if already in use."
	| newName newSet |

	self okToChange ifFalse: [^ self].
	newName _ FillInTheBlank request: 'A name for the new change set'
			initialAnswer: ChangeSet defaultName.
	newName isEmpty ifTrue: [^ self].
	(self class changeSetNamed: newName) ifNotNil:
			[^ self inform: 'Sorry that name is already used'].

	newSet _ ChangeSet new initialize name: newName.
	AllChangeSets add: newSet.
	self update.
	self showChangeSet: newSet.
	self newCurrent.

! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'di 6/14/1998 12:00'!
remove
	"Completely destroy my change set.  Check if it's OK first"

	self okToChange ifFalse: [^ self].
	self removePrompting: true.
	self update! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'di 6/14/1998 11:58'!
rename
	"Store a new name string into the selected ChangeSet.  reject duplicate name; allow user to back out"

	| newName |
	newName _ FillInTheBlank request: 'New name for this change set'
						initialAnswer: myChangeSet name.
	(newName = myChangeSet name or: [newName size == 0]) ifTrue:
			[^ self inform: 'No change made'].

	(self class changeSetNamed: newName) ifNotNil:
			[^ Utilities inform: 'Sorry that name is already used'].

	myChangeSet name: newName.
	self update.
	self changed: #mainButtonName.
	self changed: #relabel.! !


