'From Squeak 2.3 of January 14, 1999 on 23 April 1999 at 11:57:16 am'!
"Change Set:		wnld-mousefix-jsp
Date:			23 April 1999
Author:			Jeff Pierce

A quick fix to make mousing into camera windows besides the default camera window work correctly."!


!WonderlandActor methodsFor: 'get property' stamp: 'jsp 4/22/1999 17:52'!
getPositionInPixels: camera
	"Returns the actor's position in pixels in the Squeak window"

	| morph point x y frustum |

	morph _ camera getMorph.

	point _ self getPositionInPicturePlane: camera.

	frustum _ camera getFrustum.

	((point x) < 0) ifTrue: [
			x _ (morph center x) - (((point x) / (frustum left)) * ((morph width) / 2))
						]
				ifFalse: [
			x _ (morph center x) + (((point x) / (frustum right)) * ((morph width) / 2))
						].

	((point y) < 0) ifTrue: [
			y _ (morph center y) + (((point y) / (frustum bottom)) * ((morph height) / 2))
						]
				ifFalse: [
			y _ (morph center y) - (((point y) / (frustum top)) * ((morph height) / 2))
						].

	^ (x @ y) rounded.
	! !

!WonderlandActor methodsFor: 'event handling' stamp: 'jsp 4/22/1999 17:43'!
onMouseMove: event
	"The default response to mouse motion events"

	| deltaX deltaY screenPos scenePos depth camera |

	deltaX _ event getCursorDelta x.
	deltaY _ event getCursorDelta y.
	camera _ event getCamera.

	(Sensor shiftPressed)
		ifTrue: [ (Sensor controlKeyPressed)
					ifTrue: [
						"If both shift and control are pressed, tumble the bunny"
							scenePos _ self getPosition.
							self moveToRightNow: { 0. 0. 0 } asSeenBy: (myWonderland getScene)
									undoable: false.
							self turnRightNow: down numberOfTurns: (deltaY * 0.01)
									asSeenBy: (myWonderland getScene) undoable: false.
							self turnRightNow: left numberOfTurns: (deltaX * 0.01)
									asSeenBy: (myWonderland getScene) undoable: false.
							self moveToRightNow: scenePos undoable: false.

							]

					ifFalse: [
						"If only shift is pressed move the actor up/down"
						screenPos _ (self getPositionInPixels: camera) + (0@deltaY).
						scenePos _ camera transformScreenPointToScenePoint: screenPos
												atDepthOf: self.
						self moveToRightNow: (scenePos) asSeenBy: (myWonderland getScene)
								undoable: false.
							].
				]
		ifFalse: [ (Sensor controlKeyPressed)
					ifTrue: [
							scenePos _ self getPosition.
							self moveToRightNow: { 0. 0. 0 } asSeenBy: (myWonderland getScene)
									undoable: false.
							self turnRightNow: left numberOfTurns: (deltaX * 0.01)
									asSeenBy: (myWonderland getScene) undoable: false.
							self moveToRightNow: scenePos undoable: false.
							]
					ifFalse: [
						"If no modifier keys are held down, move the actor forward-back
						and left-right"
						screenPos _ (self getPositionInPixels: camera) + (deltaX@0).
						depth _ ((self getPosition: camera) at: 3) - (deltaY * 0.01).
						scenePos _ camera transformScreenVectorToSceneVector:
							(B3DVector3 x: (screenPos x) y: (screenPos y) z: depth).

						self moveToRightNow: { scenePos at: 1. asIs. scenePos at: 3 }
								asSeenBy: (myWonderland getScene) undoable: false.
							].
				].
! !


