'From Squeak 2.4b of April 23, 1999 on 30 April 1999 at 9:29:15 am'!
"Change Set:		ThreeFixes
Date:			30 April 1999
Author:			Dan Ingalls

A fix to TextOnCurve that got broken by the faster type-in code.
A fix to classComment: submitted by Mark Guzdial.
A fix to FileDirectory fileExists: that makes filename matching be case-insensitive
	with an override in UnixFileDirectory for case-sensitivity.
"!


!FileDirectory methodsFor: 'testing' stamp: 'di 4/30/1999 09:24'!
fileExists: filenameOrPath
	"Answer true if a file of the given name exists. The given name may be either a full path name or a local file within this directory."
	"FileDirectory default fileExists: Smalltalk sourcesName"

	| fName dir |
	FileDirectory splitName: filenameOrPath to:
		[:filePath :name |
			fName _ name.
			filePath isEmpty
				ifTrue: [dir _ self]
				ifFalse: [dir _ FileDirectory on: filePath]].

	dir fileNames do: [:thisName | (fName sameAs: thisName) ifTrue: [^ true]].
	^ false
! !


!TextOnCurve methodsFor: 'as yet unclassified' stamp: 'di 4/30/1999 08:06'!
composeAll
	self composeLinesFrom: firstCharacterIndex
		withLines: OrderedCollection new
		atY: container top.! !


!UnixFileDirectory methodsFor: 'file names' stamp: 'di 4/30/1999 09:27'!
fileExists: filenameOrPath
	"Overridden to implement case-sensitive fileName matching."
	"FileDirectory default fileExists: Smalltalk sourcesName"

	| fName dir |
	FileDirectory splitName: filenameOrPath to:
		[:filePath :name |
			fName _ name.
			filePath isEmpty
				ifTrue: [dir _ self]
				ifFalse: [dir _ FileDirectory on: filePath]].

	dir fileNames do: [:thisName | (fName = thisName) ifTrue: [^ true]].
	^ false
! !


