'From Squeak 2.4c of May 10, 1999 on 27 May 1999 at 1:08:47 pm'!
"Change Set:		flapTweak-sw
Date:			27 May 1999
Author:			Scott Wallace

Avoids instantiating default global flaps unnecessarily when entering morphic projects.   It should now be the case that if you set the #useGlobalFlaps preference to false and specify in the ensuing dialog that you do NOT want to preserve the existing flaps for future use, they will never be instantiated again until you proactively request that global flaps be used.

Also resets the stepTimes for the three system status lines in the 'Squeak' flap back to their desired values -- which were lost due to a change in update 1216 -- and does the same for items in any Preferences inspectors that might have been left extant in a user's image while update 1216 was being applied."!


!PasteUpMorph methodsFor: 'flaps' stamp: 'sw 5/27/1999 12:50'!
assureFlapTabsFitOnScreen
	self flapTabs do:
		[:m | 
		m orientation == #vertical
			ifTrue:
				[m  y: (m y min: (self bottom - m height))]
			ifFalse:
				[m x: (m x min: (self right - m width))]]! !

!PasteUpMorph methodsFor: 'flaps' stamp: 'sw 5/27/1999 12:50'!
bringFlapTabsToFront
	self flapTabs do:
		[:m | self addMorphFront: m]! !

!PasteUpMorph methodsFor: 'flaps' stamp: 'sw 5/27/1999 12:53'!
flapTabs
	^ self submorphs select:
		[:m | m isKindOf: FlapTab]! !

!PasteUpMorph methodsFor: 'flaps' stamp: 'sw 5/27/1999 12:42'!
localFlapTabs
	| globalList aList aFlapTab |
	globalList _ Utilities globalFlapTabsIfAny.
	aList _ OrderedCollection new.
	submorphs do:
		[:m | ((m isKindOf: FlapTab) and: [(globalList includes: m) not])
			ifTrue:
				[aList add: m]
			ifFalse:
				[((m hasProperty: #flap) and:
					[(aFlapTab _ m submorphs detect: [:n | n isKindOf: FlapTab] ifNone: [nil]) notNil])
						ifTrue:
							[aList add: aFlapTab]]].
	^ aList! !


"Postscript:
"
UpdatingStringMorph allInstances do:
	[:m | (#(version lastUpdateString currentChangeSetString) includes: m getSelector)
		ifTrue:
			[m stepTime: 3000]].

UpdatingBooleanStringMorph allInstances do:
	[:m | (m target == Preferences)
		ifTrue:
			[m stepTime: 1800]].!

