'From Squeak 2.4c of May 10, 1999 on 9 June 1999 at 2:45:25 pm'!
"Change Set:		ThreeChanges-di
Date:			9 June 1999
Author:			Dan Ingalls

Makes Object class newFrom: use basicNew instead of new.
Contracts selectors to 35 characters in the find-method menu of the browser.
Redefines SystemDictionary removeEmptyMessageCategories to share rather than duplicate existing code."!


!Object methodsFor: 'copying' stamp: 'di 6/9/1999 14:44'!
copySameFrom: otherObject
	"Copy to myself all instance variables named the same in otherObject.
	This ignores otherObject's control over its own inst vars."

	| myInstVars otherInstVars match |
	myInstVars _ self class allInstVarNames.
	otherInstVars _ otherObject class allInstVarNames.
	myInstVars doWithIndex: [:each :index |
		(match _ otherInstVars indexOf: each) > 0 ifTrue:
			[self instVarAt: index put: (otherObject instVarAt: match)]]
! !


!Object class methodsFor: 'instance creation' stamp: 'di 6/9/1999 14:27'!
newFrom: aSimilarObject
	"Create an object that has similar contents to aSimilarObject.
	If the classes have any instance varaibles with the same names, copy them across.
	If this is bad for a class, override this method."

	^ self basicNew copySameFrom: aSimilarObject! !


!SystemDictionary methodsFor: 'housekeeping' stamp: 'di 6/8/1999 15:47'!
removeEmptyMessageCategories
	"Smalltalk removeEmptyMessageCategories"
	Smalltalk garbageCollect.
	(ClassOrganizer allInstances copyWith: SystemOrganization) do:
		[:org | org removeEmptyCategories]! !


