'From Squeak 2.5 of August 6, 1999 on 31 August 1999 at 10:18:29 pm'!
"Change Set:		ColorPicker32
Date:			31 August 1999
Author:			Dan Ingalls

Makes ColorPicker work in 32 bits by ensuring the alpha bits are set in its image form.
Will also work for the most part across changes in Display color depth.
Also adds a close box and makes the default mode be stay up (until close).
"!


!ColorPickerMorph methodsFor: 'initialization' stamp: 'di 8/31/1999 22:16'!
buildChartForm
	| chartForm transText |
	chartForm _ ColorChart deepCopy asFormOfDepth: Display depth.
	Display depth >= 16 ifTrue:
		[chartForm fillBlack: (10@0 extent: 1@9).
		chartForm fill: (20@0 extent: 1@9) fillColor: Color lightGray.
		chartForm fillBlack: ((chartForm width - FeedbackBox width - 2)@0 extent: 1@9).
		chartForm fill: ((chartForm width - FeedbackBox width - 10)@0 extent: 1@9)
				fillColor: Color lightGray.
		transText _ (Form extent: 63@9 depth: 1   "Where there's a will there's a way..."
					fromArray: #( 0 0 4194306 1024 4194306 1024 15628058 2476592640
									4887714 2485462016 1883804850 2486772764 4756618
									2485462016 4748474 1939416064 0 0)
					offset: 0@0).
		transText displayOn: chartForm at: 62@0.
		Display depth = 32 ifTrue:
			["Set opaque bits for 32-bit display"
			chartForm fill: chartForm boundingBox rule: Form under
					fillColor: (Color r: 0.0 g: 0.0 b: 0.0 alpha: 1.0)]].
	chartForm borderWidth: 1.
	self form: chartForm.

! !

!ColorPickerMorph methodsFor: 'initialization' stamp: 'di 8/31/1999 22:16'!
initialize
	super initialize.
	self buildChartForm.
	self addMorph: (SimpleButtonMorph new borderWidth: 0;
			label: 'x' font: nil; color: Color transparent;
			actionSelector: #delete; target: self;
			position: 1@0; extent: 10@9).
	selectedColor _ Color white.
	sourceHand _ nil.
	deleteOnMouseUp _ false.
	updateContinuously _ true.
	selector _ nil.
	target _ nil.
! !

!ColorPickerMorph methodsFor: 'event handling' stamp: 'di 8/31/1999 21:21'!
mouseDown: evt

	Display depth = originalForm depth ifFalse: [self buildChartForm].
	sourceHand _ evt hand.
	self startStepping.
! !

!ColorPickerMorph methodsFor: 'private' stamp: 'di 8/31/1999 22:10'!
pickColorAt: aPoint 
	| worldBox globalP c alpha |
	(FeedbackBox containsPoint: aPoint - self topLeft)
		ifTrue: [^ self]. "do nothing"
	"pick up color, either inside or outside this world"
	worldBox _ self world viewBox.
	globalP _ aPoint + worldBox topLeft.
	"get point in screen coordinates"
	(worldBox containsPoint: globalP)
		ifTrue: [c _ self world colorAt: aPoint belowMorph: Morph new]
		ifFalse: [c _ Display colorAt: globalP].
	"check for transparent color and update using appropriate feedback color "
	(TransparentBox containsPoint: aPoint - self topLeft)
		ifTrue: [Display depth >= 16
				ifTrue: 
					[alpha _ (aPoint x - bounds left - 20) asFloat /
							(TransparentBox width - FeedbackBox width - 30)
							min: 1.0 max: 0.0.
					"(alpha roundTo: 0.01) printString , '   ' displayAt: 0@0." "debug"
					self updateColor: (selectedColor alpha: alpha)
						feedbackColor: (selectedColor alpha: alpha)]
				ifFalse: [self updateColor: Color transparent feedbackColor: Color white]]
		ifFalse: [self updateColor: ((selectedColor isColor and: [selectedColor isTranslucentColor])
					ifTrue: [c alpha: selectedColor alpha]
					ifFalse: [c])
				feedbackColor: c]! !


!ColorPickerMorph class methodsFor: 'as yet unclassified' stamp: 'di 8/31/1999 21:56'!
initialize
	"ColorPickerMorph initialize"

	ColorChart _ Color colorPaletteForDepth: 16 extent: 190@60.
	TransparentBox _ ColorChart boundingBox withHeight: 10.
	FeedbackBox _ (ColorChart width - 20)@1 extent: 19@8.
! !


ColorPickerMorph initialize!

