'From Squeak 2.5 of August 6, 1999 on 2 September 1999 at 9:30:37 am'!
"Change Set:		PBColorPicker
Date:			1 September 1999
Author:			Dan Ingalls

Provides continuous feedback in the PaintBox ColorPicker.
"!


!PaintBoxColorPicker methodsFor: 'event handling' stamp: 'di 9/2/1999 09:19'!
endColorSelection: evt
	"Update current color and report it to paint box."

	self selectColor: evt.

	"restore mouseLeave handling"
	self on: #mouseLeave send: #delete to: self.
	evt hand addMouseOverMorph: self.
! !

!PaintBoxColorPicker methodsFor: 'event handling' stamp: 'di 9/2/1999 09:19'!
selectColor: evt
	"Update the receiver from the given event. Constrain locOfCurrent's center to lie within the color selection area. If it is partially in the transparent area, snap it entirely into it vertically."

	| r |
	locOfCurrent _ evt cursorPoint - self topLeft.
	r _ Rectangle center: locOfCurrent extent: 9@9.
	locOfCurrent _ locOfCurrent + (r amountToTranslateWithin: (5@11 corner: 140@136)).
	locOfCurrent x > 128 ifTrue: [locOfCurrent _ 135@locOfCurrent y].  "snap into grayscale"
	locOfCurrent y < 17
		ifTrue: [
			locOfCurrent _ locOfCurrent x@11.  "snap into transparent"
			currentColor _ Color transparent]
		ifFalse: [
			currentColor _ image colorAt: locOfCurrent].

	(owner isKindOf: PaintBoxMorph) ifTrue: [owner takeColorFrom: self].

	self changed.
! !


!PaintBoxMorph methodsFor: 'actions' stamp: 'di 9/2/1999 09:25'!
takeColorEvt: evt from: colorPicker

	^ self takeColorFrom: colorPicker! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'di 9/2/1999 09:18'!
takeColorFrom: colorPicker
	"Accept a new color from the colorMemory.  Programs use currentColor: instead.  Do not do this before the picker has a chance to set its own color!!"

	currentColor _ colorPicker currentColor.
	self showColor.
	self colorable ifFalse: [self setAction: #paint:].	"User now thinking of painting"! !


