'From Squeak 2.5 of August 6, 1999 [latest update: #1516] on 6 October 1999 at 3:09:28 pm'!
"Change Set:		MarkBitFix
Date:			6 October 1999
Author:			Dan Ingalls

The rootArray and roots for an imageSegment are marked and the mark bits were incorrectly being copied into the segment.  This fixes taht problem by masking them out, along with the root bits, during copy."!


!Interpreter methodsFor: 'image segment in/out' stamp: 'di 10/5/1999 19:09'!
copyObj: oop toSegment: segmentWordArray addr: lastSeg stopAt: stopAddr saveOopAt: oopPtr headerAt: hdrPtr
	"Copy this object into the segment beginning at lastSeg.
	Install a forwarding pointer, and save oop and header.
	Fail if out of space.  Return the next segmentAddr if successful."

	"Copy the object..."
	| extraSize bodySize hdrAddr |
	successFlag ifFalse: [^ lastSeg].
	extraSize _ self extraHeaderBytes: oop.
	bodySize _ self sizeBitsOf: oop.
	(lastSeg + extraSize + bodySize) >= stopAddr
		ifTrue: [^ self primitiveFail].
	self transfer: extraSize + bodySize // 4  "wordCount"
		from: oop - extraSize
		to: lastSeg+4.

	"Clear root and mark bits of all headers copied into the segment"
	hdrAddr _ lastSeg+4 + extraSize.
	self longAt: hdrAddr put: ((self longAt: hdrAddr) bitAnd: AllButRootBit - MarkBit).

	self forward: oop to: (lastSeg+4 + extraSize - segmentWordArray)
		savingOopAt: oopPtr andHeaderAt: hdrPtr.

	"Return new end of segment"
	^ lastSeg + extraSize + bodySize! !


