'From Squeak 2.5 of August 6, 1999 [latest update: #1540] on 11 October 1999 at 5:52:19 pm'!
"Change Set:		sundry-sw
Date:			11 October 1999
Author:			Scott Wallace

(1) Revert-to-previous-version and Revert-and-forget commands in browsers, etc., now restore the time stamp of the reverted-to method rather than adding a current one.

(2) #printOn: methods for CompiledMethod and MorphExtension now give more useful information.

(3)  Inspector menu offers 'methods storing into this inst var'.
"!


!CompiledMethod methodsFor: 'printing' stamp: 'sw 10/10/1999 14:43'!
printOn: aStream 
	"Overrides method inherited from the byte arrayed collection."

	aStream nextPutAll: 'a CompiledMethod ', self identityHashPrintString! !


!MorphExtension methodsFor: 'other' stamp: 'sw 10/7/1999 15:16'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' ', self identityHashPrintString.
	locked == true ifTrue: [aStream nextPutAll: ' [locked] '].
	visible == false ifTrue: [aStream nextPutAll: '[not visible] '].
	sticky == true ifTrue: [aStream nextPutAll: ' [sticky] '].
	balloonText ifNotNil: [aStream nextPutAll: ' [balloonText] '].
	balloonTextSelector ifNotNil: [aStream nextPutAll: ' [balloonTextSelector: ', balloonTextSelector printString, '] '].
	externalName ifNotNil: [aStream nextPutAll: ' [externalName = ', externalName, ' ] '].
	isPartsDonor == true ifTrue: [aStream nextPutAll: ' [isPartsDonor] '].
	player ifNotNil: [aStream nextPutAll: ' [player = ', player printString, '] '].
	eventHandler ifNotNil: [aStream nextPutAll: ' [eventHandler = ', eventHandler printString, '] '].
	otherProperties isEmptyOrNil ifTrue: [^ self].

	aStream nextPutAll: ' [other: '.
	otherProperties keysDo: [:aKey | aStream nextPutAll: ' (', aKey, ' -> ', (otherProperties at: aKey) printString, ')'].
	aStream nextPut: $]! !


!PasteUpMorph methodsFor: 'project state' stamp: 'sw 10/9/1999 22:51'!
isStepping: aMorph
	^ worldState isStepping: aMorph! !


!StringHolder methodsFor: 'message list menu' stamp: 'sw 10/10/1999 22:05'!
revertToPreviousVersion
	"Revert to the previous version of the current method"
	| aClass aSelector  changeRecords |
	self okToChange ifFalse: [^ self].
	aClass _ self selectedClassOrMetaClass.
	aClass ifNil: [^ self changed: #flash].
	aSelector _ self selectedMessageName.
	changeRecords _ aClass changeRecordsAt: aSelector.
	(changeRecords == nil or: [changeRecords size <= 1]) ifTrue: [self changed: #flash.  ^ self beep].
	changeRecords second fileIn.
	self contentsChanged
! !


!Inspector methodsFor: 'menu commands' stamp: 'sw 10/10/1999 14:34'!
defsOfSelection
	"Open a browser on all defining references to the selected instance variable, if that's what currently selected. "
	| aClass sel |

	self selectionUnmodifiable ifTrue: [^ self changed: #flash].
	(aClass _ self object class) isVariable ifTrue: [^ self changed: #flash].

	sel _ aClass allInstVarNames at: self selectionIndex - 2.
	aClass browseAllStoresInto: sel! !

!Inspector methodsFor: 'menu commands' stamp: 'sw 10/10/1999 21:44'!
fieldListMenu: aMenu

	^ aMenu labels: 'inspect (i)
explore (I)
method refs to this inst var
methods storing into this inst var
objects pointing to this value
copy name
browse full (b)
browse class
inst var refs...
inst var defs...
class var refs...
class variables
class refs
basic inspect'
	lines: #(2 5 6 8 10 13 )
	selections: #(inspectSelection exploreSelection referencesToSelection defsOfSelection objectReferencesToSelection copyName  browseMethodFull browseClass browseInstVarRefs browseInstVarDefs classVarRefs browseClassVariables browseClassRefs inspectBasic).
! !


