'From Squeak 2.1 of June 30, 1998 on 30 July 1998 at 7:53:53 pm'!
"Change Set:		DateFromSeconds
Date:			30 July 1998
Author:			Lex Spoon

As pointed out by John, why not have a Date>>fromSeconds:, since the functionality does get needed a few times?  This adds the method and changes a few locations to use it"!


!Date class methodsFor: 'instance creation' stamp: 'ls 7/25/1998 01:15'!
fromSeconds: seconds
	"Answer an instance of me which is 'seconds' seconds after January 1, 
	1901."

	^self fromDays: seconds // 86400! !


!FileList methodsFor: 'volume list and pattern' stamp: 'ls 7/25/1998 01:15'!
fileNameFormattedFrom: entry sizePad: sizePad
	"entry is a 5-element array of the form:
		(name creationTime modificationTime dirFlag fileSize)"
	| sizeStr nameStr dateStr |
	nameStr _ (entry at: 4)
		ifTrue: [entry first , self folderString]
		ifFalse: [entry first].
	dateStr _ ((Date fromSeconds: (entry at: 3) )
					printFormat: #(3 2 1 $. 1 1 2)) , ' ' ,
				(String streamContents: [:s |
					(Time fromSeconds: (entry at: 3) \\ 86400)
						print24: true on: s]).
	sizeStr _ (entry at: 5) asStringWithCommas.
	sortMode = #name ifTrue:
		[^ nameStr , '    (' , dateStr , ' ' , sizeStr , ')'].
	sortMode = #date ifTrue:
		[^ '(' , dateStr , ' ' , sizeStr , ') ' , nameStr].
	sortMode = #size ifTrue:
		[^ '(' , ((sizeStr size to: sizePad) collect: [:i | $ ]) , sizeStr , ' ' , dateStr , ') ' , nameStr].
! !


!Time class methodsFor: 'general inquiries' stamp: 'ls 7/25/1998 01:16'!
dateAndTimeFromSeconds: secondCount

	^ Array
		with: (Time fromSeconds: secondCount \\ 86400)
		with: (Date fromSeconds: secondCount)
! !

!Time class methodsFor: 'general inquiries' stamp: 'ls 7/25/1998 01:16'!
dateAndTimeNow
	"Answer a two-element Array of (Date today, Time now)."

	| secondCount d t |
	secondCount _ self primSecondsClock.
	d _ Date fromSeconds: secondCount.
	t _ Time fromSeconds: secondCount \\ 86400.
	^ Array with: d with: t! !


