'From Squeak2.6 of 11 October 1999 [latest update: #1736] on 28 December 1999 at 2:56:16 pm'!
"Change Set:		autoViewing
Date:			28 December 1999
Author:			Scott Wallace

When a playfield is set up for automatic viewing, that viewing now will take place whenever an object within it is 'touched' -- thus, the viewer comes up even after a click on a text object, on an object scripted to handle mouse actions, on a joystick, etc  Formerly, this only worked if you 'picked up' an object and then dropped it back into the playfield, making every situation where a simple click on an object did not serve to 'pick it up' problematical."!


!Morph methodsFor: 'e-toy support' stamp: 'sw 12/20/1999 17:36'!
automaticViewing
	"Backstop, in case this message gets sent to an owner that is not a playfield"
	^ false! !


!HaloMorph methodsFor: 'private' stamp: 'sw 12/20/1999 17:49'!
startDrag: evt with: dragHandle
	| itsOwner |
	"Drag my target without removing it from its owner."

	self removeAllHandlesBut: dragHandle.
	positionOffset _ dragHandle center - target positionInWorld.

	 ((itsOwner _ target topRendererOrSelf owner) notNil and:
			[itsOwner automaticViewing]) ifTrue:
				[target openViewerForArgument]

! !


!HandMorph methodsFor: 'event handling' stamp: 'sw 11/6/1999 11:30'!
newMouseFocus: aMorphOrNil

	| itsOwner |
	((mouseDownMorph isKindOf: MenuItemMorph)
		and: [(aMorphOrNil isKindOf: MenuItemMorph) not])
		ifTrue: [(mouseDownMorph owner isKindOf: MenuMorph)
				ifTrue: ["Crock: If a menu is proffered with the mouse up
						and the user clicks down outside it (as is normal in MVC),
						then the menu goes away and nothing else happens."
						mouseDownMorph owner deleteIfPopUp.
						^ nil]].
	aMorphOrNil ifNotNil: 
		[((itsOwner _ aMorphOrNil topRendererOrSelf owner) notNil and:
			[itsOwner automaticViewing]) ifTrue:
				[aMorphOrNil openViewerForArgument]].

	mouseDownMorph _ aMorphOrNil.
	self updateMouseDownTransform.
! !

!HandMorph methodsFor: 'special gestures' stamp: 'sw 12/21/1999 16:04'!
specialDrag: evt
	"Special drag (cmd-mouse on the Macintosh) allows a morph to be dragged without grabbing it and thus without removing it from its owner or changing its z-order." 
	| halo itsOwner |
	self position ~= evt cursorPoint
		ifTrue: [self position: evt cursorPoint].
	mouseDownMorph
		ifNil:    ["Waiting for more than 5 pixels move to start drag"
				(self position dist: targetOffset) > 5
					ifTrue: [(halo _ self world haloMorphOrNil) ifNil: [^ self].
							mouseDownMorph _ halo target.
							targetOffset _ targetOffset - mouseDownMorph positionInWorld.
							halo removeAllHandlesBut: nil]]
		ifNotNil: [mouseDownMorph setConstrainedPositionFrom:
					(mouseDownMorph pointFromWorld: self position - targetOffset)].

	 mouseDownMorph ifNotNil:
		[((itsOwner _ mouseDownMorph topRendererOrSelf owner) notNil and:
			[itsOwner automaticViewing]) ifTrue:
				[mouseDownMorph openViewerForArgument]]
! !


!JoystickMorph methodsFor: 'other' stamp: 'sw 5/11/1998 13:51'!
handlesMouseDown: evt

	self inPartsBin ifTrue: [^ false].

	true ifTrue: [^ true].  "5/7/98 jhm temporary fix to allow use when rotated"

	(handleMorph fullContainsPoint: evt cursorPoint)
		ifTrue: [^ true]
		ifFalse: [^ super handlesMouseDown: evt].
! !


