'From Squeak2.8alpha of 13 January 2000 [latest update: #1854] on 14 February 2000 at 10:32:12 pm'!
"Change Set:		Cmd-q-tkNF
Date:			14 February 2000
Author:			Ted Kaehler

Alt-q (Command-q) does name completion.  Extends name completion to class names, global variables, and category names.  If the text starts with an uppercase letter, then non-selector symbols (class names, etc.) are searched.
	Thought about extending completion to local variables, and instance variables, but this is very mess.  Not enough state is kept between completions to make this easy."!


!Symbol class methodsFor: 'access' stamp: 'tk 2/11/2000 21:16'!
otherThatStarts: leadingCharacters skipping: skipSym
	"Answer a selector symbol with leadingCharacters that 
		starts with an uppercase letter. Ignore case in aKeyword.
	If skipSym is not nil, it is a previous answer; start searching after it.
	If no symbols are found, answer nil.
	Used by Alt-q (Command-q) routines."

	| key size table candidate ii skip |
	key _ leadingCharacters asLowercase.
	size _ key size.
	skip _ skipSym ~~ nil.
	(1 to: OtherTable size) do:
		[:jj |
		table _ OtherTable at: jj.
		1 to: table size do: 
			[:tt | 
			((candidate _ table at: tt) == nil or:
					[skip and: [skip _ candidate ~~ skipSym. true]]) ifFalse:
				[candidate size >= size ifTrue:
					[ii _ size. "test last character first"
					 [ii > 0 and: [(candidate at: ii) asLowercase == (key at: ii)]]
						whileTrue: [ii _ ii - 1].
					 ii = 0 ifTrue: [^candidate]]]]].
	^nil

"Symbol otherThatStarts: 'morph' skipping: nil"
"Symbol otherThatStarts: 'morph' skipping: #'Morphic-Support'"
"Symbol otherThatStarts: 'rect' skipping: #'rectangle functions'"
! !

!Symbol class methodsFor: 'access' stamp: 'tk 2/11/2000 21:30'!
thatStarts: leadingCharacters skipping: skipSym
	"Answer a selector symbol that starts with leadingCharacters.
	Symbols beginning with a lower-case letter handled directly here.
	Ignore case after first char.
	If skipSym is not nil, it is a previous answer; start searching after it.
	If no symbols are found, answer nil.
	Used by Alt-q (Command-q) routines."

	| key size index table candidate i skip firstTable |
	key _ leadingCharacters asLowercase.
	index _ key first asciiValue - "($a asciiValue - 1)" 96.
	((index >= 1) and:
		[(index <= 26) and:
		[leadingCharacters numArgs >= 0]])
			ifFalse: [^ self otherThatStarts: leadingCharacters skipping: skipSym].
	size _ key size.
	skip _ skipSym ~~ nil.
	firstTable _ skip
		ifTrue: [skipSym numArgs + 1 min: SelectorTables size] "can't be in a later table"
		ifFalse: [SelectorTables size]. "could be in any table; favor longer identifiers"
	(firstTable to: 1 by: -1) do:
		[:j |
		table _ (SelectorTables at: j) at: index.
		1 to: table size do: 
			[:t | 
			((candidate _ table at: t) == nil or:
					[skip and: [skip _ candidate ~~ skipSym. true]]) ifFalse:
				[candidate size >= size ifTrue:
					[i _ size. "test last character first"
					 [i > 1 and: [(candidate at: i) asLowercase == (key at: i)]]
						whileTrue: [i _ i - 1].
					 i = 1 ifTrue: "don't need to compare first character"
						[^candidate]]]]].
	^nil

"Symbol thatStarts: 'sf' skipping: nil"
"Symbol thatStarts: 'sf' skipping: #sfpGetFile:with:with:with:with:with:with:with:with:"
"Symbol thatStarts: 'candidate' skipping: nil"
! !


