'From Squeak2.8alpha of 12 January 2000 [latest update: #2039] on 25 April 2000 at 12:45:45 pm'!
"Change Set:		SymbolPrinting
Date:			25 April 2000
Author:			Roel Wuyts, Dan Ingalls

This changeSet incorporates Roel Wuyts's suggested change to print symbols with a #-sign in their printString.

It also uses the #'any chars' construct to ensure that any symbol can be printed as a literal.  
NOTE:  This implies a change in the definition of Symbol>>isLiteral to always return true (it used only to return true for symbols that can be printed without string quotes as #someSymbol).  If you really want to test whether a symbol can be printed without string quotes, then use the expression (Scanner isLiteralSymbol: theSymbol).
"!


!ChangeSorter methodsFor: 'message list' stamp: 'di 4/25/2000 10:33'!
messageList 

	| probe newSelectors |
	currentClassName ifNil: [^ #()].
	probe _ (currentClassName endsWith: ' class')
		ifTrue: [currentClassName]
		ifFalse: [currentClassName asSymbol].
	newSelectors _ myChangeSet selectorsInClass: probe.
	(newSelectors includes: currentSelector) ifFalse: [currentSelector _ nil].
	^ newSelectors asSortedCollection
! !


!Symbol methodsFor: 'printing' stamp: 'rw 4/6/2000 10:41'!
printOn: aStream

	self storeOn: aStream! !

!Symbol methodsFor: 'printing' stamp: 'di 4/25/2000 12:32'!
storeOn: aStream 

	aStream nextPut: $#.
	(Scanner isLiteralSymbol: self)
		ifTrue: [aStream nextPutAll: self]
		ifFalse: [super storeOn: aStream]! !

!Symbol methodsFor: 'testing' stamp: 'di 4/25/2000 12:32'!
isLiteral
	"Answer whether the receiver is a valid Smalltalk literal."

	^ true! !

