'From Squeak2.8alpha of 12 January 2000 [latest update: #2040] on 27 April 2000 at 7:03:20 pm'!
"Change Set:		DropShadowTweaks
Date:			27 April 2000
Author:			Dan Ingalls

Several improvements in the control over morphs with drop shadows (thanks to Scott Wallace for helping to track down the loose ends):

The halo properly shows the name of the target object.
Resize control goes properly to the shadowed morph.
The morph menu now includes three items for control over the shadow.
"!


!Morph methodsFor: 'menus' stamp: 'di 4/27/2000 18:52'!
addDropShadowItemsTo: aMenu hand: aHand

	"Overridden in DSMorph"! !


!DropShadowMorph methodsFor: 'menu' stamp: 'di 4/27/2000 18:52'!
addDropShadowItemsTo: aMenu hand: aHand

	aMenu addLine.
	aMenu add: 'set shadow color' target: self selector: #changeColor.
	aMenu add: 'set shadow offset' target: self selector: #setOffset:.
	aMenu add: 'remove shadow' target: self selector: #removeDropShadow.
! !


!HaloMorph methodsFor: 'private' stamp: 'di 4/27/2000 17:38'!
addName
	self addNameBeneath: self basicBox string: target renderedMorph externalName! !

!HaloMorph methodsFor: 'private' stamp: 'di 4/27/2000 17:45'!
doGrow: evt with: growHandle

	| newExtent |
	newExtent _ (target pointFromWorld: (evt cursorPoint - positionOffset)) - target topLeft.
	evt shiftPressed ifTrue: [newExtent _ (newExtent x max: newExtent y) asPoint].
	target renderedMorph extent: (newExtent max: minExtent).
	growHandle position: evt cursorPoint - (growHandle extent // 2).
	self layoutChanged.
! !

!HaloMorph methodsFor: 'private' stamp: 'di 4/27/2000 18:53'!
doMenu: evt with: menuHandle
	"Ask hand to invoke the halo menu for my inner target."

	| menu |
	self removeAllHandlesBut: nil.  "remove all handles"
	self world displayWorld.
	menu _ evt hand buildMorphHandleMenuFor: innerTarget.
	target addDropShadowItemsTo: menu hand: evt hand.
	innerTarget addTitleForHaloMenu: menu.
	evt hand invokeMenu: menu event: evt.
! !

