'From Squeak2.8alpha of 12 January 2000 [latest update: #2062] on 4 May 2000 at 12:41:47 pm'!
"Change Set:		MorphTweaks
Date:			3 May 2000
Author:			Dan Ingalls

A bunch of little fixes...
Drop shadows now work on objects with submorphs
They properly only respond to events within the shape of their submorphs
It is possible to nest one drop-shadow on another and to control each level by using the sumborphs... control in the ctrl-morph menu.
The 'debug...' menu item now appears only once in the morph menu, and that only when Preferences noviceMode is false.
"!


!Morph methodsFor: 'geometry testing' stamp: 'di 5/3/2000 19:05'!
fullContainsPoint: aPoint

	(self fullBounds containsPoint: aPoint) ifFalse: [^ false].  "quick elimination"
	(self containsPoint: aPoint) ifTrue: [^ true].  "quick acceptance"
	submorphs do: [:m | (m fullContainsPoint: aPoint) ifTrue: [^ true]].
	^ false
! !


!DropShadowMorph methodsFor: 'geometry' stamp: 'di 5/3/2000 16:47'!
containsPoint: pt

	self hasSubmorphs ifFalse: [^ super containsPoint: pt].
	^ self firstSubmorph containsPoint: pt! !

!DropShadowMorph methodsFor: 'private' stamp: 'di 5/3/2000 16:46'!
computeBounds
	submorphs isEmpty ifTrue:
		[self extent: 50@40.
		fullBounds _ nil.
		^ self].
	self changed.
	bounds _ (submorphs first fullBounds) copy.
	bounds _ fullBounds _ (bounds translateBy: shadowOffset) merge: bounds.
	self changed! !


!HandMorph methodsFor: 'world menu commands' stamp: 'di 5/3/2000 17:26'!
buildMorphHandleMenuFor: argMorph
	"Build the morph menu for the given morph's halo's menu handle. This menu has two sections. The first section contains commands that are interpreted by the hand; the second contains commands provided by the target morph. This method allows the morph to decide which items should be included in the hand's section of the menu."

	| menu |
	argMorph == owner "i.e., the world" ifTrue:
		[^ self buildWorldMenu].

	argument _ argMorph.
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	argMorph addAddHandMenuItemsForHalo: menu hand: self.
	menu defaultTarget: argMorph.
	argMorph addCustomHaloMenuItems: menu hand: self.
	menu addLine.

	argMorph player ifNotNil: [argMorph player addPlayerMenuItemsTo: menu hand: self].
	menu defaultTarget: self.

	^ menu
! !

