'From Squeak2.8alpha of 4 February 2000 [latest update: #2158] on 20 May 2000 at 6:41:01 pm'!
"Change Set:		076RomanNumbers-sma
Date:			21 May 2000
Author:			Stefan Matthias Aust & Andreas Kuckartz

Andreas wrote: 

The current method WatchMorph>>createLabels contains the following fragment:
	#('I' 'II' 'III' 'IV' 'V' 'VI' 'VII' ' VIII' 'IX' 'X' 'XI' 'XII') at: hour

Nobody seems to have added a decent method for Roman Numerals to Smalltalk
in the last twenty years. I wrote one (which was not following the correct
rules and therefore was not decent) many years ago and posted it in one of
the Usenet newsgroups. Unfortunately the old Usenet archives at deja.com are
not accessible for the next few months and I do not have a copy of that
method...

Therefore I today have written a new version which hopefully follows the
rules of the old Romans.

I rewrote it, reducing its size, named it to #romanString and also added a new method #romanNumber to convert strings back to integers.  --sma"!


!Integer methodsFor: 'printing' stamp: 'sma 5/20/2000 17:03'!
romanString	"1999 romanString"
	[self > 0] assert.
	^ String streamContents:
		[:s |
		self // 1000 timesRepeat: [s nextPut: $M].
		self romanDigits: 'MDC' for: 100 on: s.
		self romanDigits: 'CLX' for: 10 on: s.
		self romanDigits: 'XVI' for: 1 on: s]! !

!Integer methodsFor: 'private' stamp: 'sma 5/20/2000 17:00'!
romanDigits: digits for: base on: aStream
	| n |
	n _ self \\ (base * 10) // base.
	n = 9 ifTrue: [^ aStream nextPut: digits last; nextPut: digits first].
	n = 4 ifTrue: [^ aStream nextPut: digits last; nextPut: digits second].
	n > 4 ifTrue: [aStream nextPut: digits second].
	n \\ 5 timesRepeat: [aStream nextPut: digits last]! !


!String methodsFor: 'converting' stamp: 'sma 5/20/2000 17:17'!
romanNumber
	| value v1 v2 |
	value _ v1 _ v2 _ 0.
	self reverseDo:
		[:each |
		v1 _ #(1 5 10 50 100 500 1000) at: ('IVXLCDM' indexOf: each).
		v1 >= v2
			ifTrue: [value _ value + v1]
			ifFalse: [value _ value - v1].
		v2 _ v1].
	^ value! !


!WatchMorph methodsFor: 'labels' stamp: 'ak 5/19/2000 21:47'!
createLabels
	| numeral font h r |
	self removeAllMorphs.
	font _ StrikeFont familyName: fontName size: (h _ self height min: self width)//8.
	r _ 1.0 - (1.4 * font height / h).
	1 to: 12 do:
		[:hour |
		numeral _ romanNumerals
			ifTrue: [hour romanString]
			ifFalse: [hour asString].
		self addMorphBack: ((StringMorph contents: numeral font: font emphasis: 1)
			center: (self radius: r hourAngle: hour)) lock]! !

