'From Squeak2.8alpha of 13 January 2000 [latest update: #2237] on 5 June 2000 at 2:04:07 pm'!
"Change Set:		pasteUpClip-sw
Date:			5 June 2000
Author:			Scott Wallace

Makes pasteUpMorphs do a much better job of clipping when mouse-handling, both for mouseover dispatch and for mouse-down dispatch.

A concomitant of these changes is that the #minimumExtent and minimumExtent: methods are elevated from SystemWindow to generic Morph."!


!Morph methodsFor: 'drawing' stamp: 'sw 6/4/2000 22:02'!
boundingBoxOfSubmorphs
	| aBox |
	aBox _ bounds origin extent: self minimumExtent.  "so won't end up with something empty"
	submorphs do:
		[:m | m visible ifTrue: [aBox _ aBox quickMerge: m fullBounds]].
	^ aBox
! !

!Morph methodsFor: 'geometry' stamp: 'sw 6/4/2000 21:59'!
minimumExtent
	| ext |
	"This returns the minimum extent that the morph may be shrunk to.  Not honored in too many places yet, but respected by the resizeToFit feature, at least.  copied up from SystemWindow 6/00"
	(ext _ self valueOfProperty: #minimumExtent)
		ifNotNil:
			[^ ext].
	^ 100 @ 80! !

!Morph methodsFor: 'geometry' stamp: 'sw 6/4/2000 22:00'!
minimumExtent: aPoint
	"Remember a minimumExtent, for possible future use"

	self setProperty: #minimumExtent toValue: aPoint
! !


!PasteUpMorph methodsFor: 'layout' stamp: 'sw 6/4/2000 23:58'!
fixLayout
	"Pack my submorphs into rows that fit within my width, if autoLineLayout is true."

	| nextY i morphsForThisRow |
	self invalidRect: bounds.
	self autoLineLayout ifTrue:
		[nextY _ bounds top + borderWidth.
		i _ 1.
		[i <= submorphs size] whileTrue:
			[morphsForThisRow _ self rowMorphsStartingAt: i.
			nextY _ self layoutRow: morphsForThisRow lastRowBase: nextY.
			i _ i + morphsForThisRow size]]
! !

!PasteUpMorph methodsFor: 'options' stamp: 'sw 6/3/2000 01:08'!
resizeToFit
	"Answer whether the receiver exhibits the #resizeToFit property.  Formerly of greater use, this is an obscure backwater not meriting much attention.  For most practical purposes, this is just always false.  The feature doesn't quite work right even where used, e.g. in the Tabs sorter"
	^ resizeToFit ifNil: [resizeToFit _ false]! !

!PasteUpMorph methodsFor: 'misc' stamp: 'sw 6/4/2000 23:39'!
fullBounds

	| result oldBounds |
	(fullBounds == nil and: [self autoLineLayout]) ifTrue:
		[oldBounds _ bounds.
		self fixLayout.
		result _ self boundingBoxOfSubmorphs.
		bounds _ bounds withBottom: result bottom.
		fullBounds _ bounds.
		self invalidRect: oldBounds.
		self changed.
		^ bounds].  "compute fullBounds before calling changed to avoid infinite recursion!!"

	^ fullBounds _ bounds
! !

!PasteUpMorph methodsFor: 'misc' stamp: 'sw 6/3/2000 00:54'!
morphsAt: aPoint addTo: mList
	"Overridden to exclude spurious hits on extralimital submorphs."
	(self containsPoint: aPoint) ifTrue:
		[submorphs size > 0 ifTrue:
			[submorphs do: [:m | m morphsAt: aPoint addTo: mList]].
		mList addLast: self].
	^ mList! !

!PasteUpMorph methodsFor: 'misc' stamp: 'sw 6/4/2000 21:42'!
unlockedMorphsAt: aPoint addTo: mList
	"Overridden to exclude spurious hits on extralimital submorphs."
	((self containsPoint: aPoint) and: [self isLocked not]) ifTrue:
		[submorphs size > 0 ifTrue:
			[submorphs do: [:m | m unlockedMorphsAt: aPoint addTo: mList]].
		mList addLast: self].
	^ mList! !

SystemWindow removeSelector: #minimumExtent!
SystemWindow removeSelector: #minimumExtent:!
PasteUpMorph removeSelector: #resizeIfNeeded!
