'From Squeak2.8alpha of 4 February 2000 [latest update: #2210] on 5 June 2000 at 9:26:23 am'!
"Change Set:		114HiddenScrFix-sma
Date:			3 June 2000
Author:			Stefan Matthias Aust

Bugfix for #112.  File-in to revert my fix to Doug's code."!


!PluggableTextMorph methodsFor: 'geometry' stamp: 'dew 10/17/1999 19:41'!
resetExtent
	"Reset the extent while maintaining the current selection.  Needed when resizing while the editor is active (when inside the pane)."
	| tempSelection |
	textMorph notNil ifTrue:
		["the current selection gets munged by resetting the extent, so store it"
		tempSelection _ self selectionInterval.
		"don't reset it if it's not active"
		tempSelection = (Interval from: 1 to: 0) ifTrue: [^ self].
		self extent: self extent.
		self setSelection: tempSelection]! !


!String methodsFor: 'internet' stamp: 'sma 6/3/2000 20:26'!
unescapePercents
	"change each %XY substring to the character with ASCII value XY in hex.  This is the opposite of #encodeForHTTP"
	| ans c asciiVal pos oldPos specialChars |
	ans _ WriteStream on: String new.
	oldPos _ 1.
	specialChars _ '+%' asCharacterSet.

	[pos _ self indexOfAnyOf: specialChars startingAt: oldPos. pos > 0]
	whileTrue: [
		ans nextPutAll: (self copyFrom: oldPos to: pos - 1).
		c _ self at: pos.
		c = $+ ifTrue: [ans nextPut: $ ] ifFalse: [
			(c = $% and: [pos + 2 <= self size]) ifTrue: [
				asciiVal _ (self at: pos+1) asUppercase digitValue * 16 +
					(self at: pos+2) asUppercase digitValue.
				pos _ pos + 2.
				ans nextPut: (Character value: asciiVal)]
			ifFalse: [ans nextPut: c]].
		oldPos _ pos+1].
	ans nextPutAll: (self copyFrom: oldPos to: self size).
	^ ans contents! !

String removeSelector: #fastUnescapePercents!
String removeSelector: #slowUnescapePercents!
