'From Squeak2.8alpha of 13 January 2000 [latest update: #2304] on 9 June 2000 at 6:48:53 pm'!
"Change Set:		sketchThumbnail-sw
Date:			9 June 2000
Author:			Scott Wallace

Further chasings of ones own tail regarding the pursuit of consistent dockup of morph and player in the presence of TransformationMorphs...  When a new Sketch was drawn in a quite large painting area, the painting system was often returning a spurious,  nonzero but vanishingly small (order of 1E-14) forward-direction, resulting in the premature launching of an unwanted TransformationMorph for the newborn -- the result of round-off error when computing forward-direction.  This workaround simply maps such spurious tiny offsets returned from the painting system back to zero, which appears to avoid the problem of plain gray thumbnails, which can be traced to this situation."!


!SketchEditorMorph methodsFor: 'access' stamp: 'sw 6/9/2000 18:48'!
forwardDirection
	"The direction object will go when issued a sent forward:.  Up is
zero.  Clockwise like a compass.  From the arrow control."

	| bb result |
	bb _ (self valueOfProperty: #fwdButton).
	result _ (self center - bb vertices first) degrees - 90.0.
	result abs < 1.0e-10 ifTrue: [result _ 0].  
	"Workaround because the above can yield spurious miscroscopic but nonzero values"
	^ result! !


!StandardScriptingSystem methodsFor: 'utilities' stamp: 'sw 6/9/2000 18:44'!
reinvigorateThumbnailsInViewerFlapTabs
	"It has happened that the thumbnail in a viewer flap tab will go solid gray because it got associated with some passing and disused player temporarily created during the initial painting process.  This method takes a sledge hammer to repair such thumbnails.   At its genesis, this method is called only from the postscript of its defining fileout."
	| vwr thumbnail |
	ViewerFlapTab allInstancesDo:
		[:aTab | 
			vwr _ aTab referent findA: StandardViewer.
			thumbnail _ aTab findA: ThumbnailMorph.
			(vwr notNil and: [thumbnail notNil]) ifTrue:
				[thumbnail objectToView: vwr scriptedPlayer]]

	"ScriptingSystem reinvigorateThumbnailsInViewerFlapTabs"! !


!ThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'sw 6/9/2000 18:35'!
objectToView: objectOrNil
	(objectOrNil isMorph and: [objectOrNil allMorphs includes: self]) ifTrue:
		["cannot view a morph containing myself or drawOn: goes into infinite recursion"
		objectToView _ nil.
		^ self].
	objectToView _ objectOrNil! !

!ThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'sw 6/9/2000 18:35'!
objectToView: objectOrNil viewSelector: aSelector
	self objectToView: objectOrNil.
	viewSelector _ aSelector! !

"Postscript:"
ScriptingSystem reinvigorateThumbnailsInViewerFlapTabs.
!

