'From Squeak2.8alpha of 12 January 2000 [latest update: #2315] on 12 June 2000 at 12:27:00 pm'!
"Change Set:		Retract2023
Date:			12 June 2000
Author:			Dan Ingalls

In response to reports on the Squeak List, this retracts update #2023.
"!


!ControlManager methodsFor: 'scheduling'!
scheduleActiveNoTerminate: aController 
	"Make aController be the active controller. Presumably the process that 
	requested the new active controller wants to keep control to do more 
	activites before the new controller can take control. Therefore, do not 
	terminate the currently active process."

	self schedulePassive: aController.
	self scheduled: aController
		from: Processor activeProcess! !


!Debugger methodsFor: 'private' stamp: 'di 4/14/2000 16:24'!
resumeProcess: aTopView

	Smalltalk isMorphic ifFalse: [aTopView erase].
	savedCursor ifNotNil: [Sensor currentCursor: savedCursor].
	isolationHead ifNotNil:
		[failedProject enterForEmergencyRecovery.
		isolationHead invoke. isolationHead _ nil].
	interruptedProcess suspendedContext method
			== (Process compiledMethodAt: #terminate)
		ifFalse:
		[contextStackIndex > 1
			ifTrue: [interruptedProcess popTo: self selectedContext]
			ifFalse: [interruptedProcess install: self selectedContext].
		Smalltalk isMorphic
			ifTrue: [Project current resumeProcess: interruptedProcess]
			ifFalse: [ScheduledControllers
						activeControllerNoTerminate: interruptedController
						andProcess: interruptedProcess]].

	"if old process was terminated, just terminate current one"
	interruptedProcess _ nil. "Before delete, so release doesn't terminate it"
	Smalltalk isMorphic
		ifTrue: [aTopView delete. World displayWorld]
		ifFalse: [aTopView controller closeAndUnscheduleNoErase].
	Smalltalk installLowSpaceWatcher.  "restart low space handler"
	Processor terminateActive
! !

