'From Squeak2.9alpha of 12 June 2000 [latest update: #2561] on 1 September 2000 at 2:54:24 pm'!
"Change Set:		EventFix-ar
Date:			1 September 2000
Author:			Andreas Raab

Fixes a bug in reporting the interrupt key which was testing for the time stamp rather than the press code." !


!EventSensor methodsFor: 'private-I/O' stamp: 'ar 9/1/2000 14:53'!
processEvent: evt
	"Process a single event. This method is run at high priority."
	| type |
	type _ evt at: 1.

	"Check if the event is a user interrupt"
	(type = EventTypeKeyboard and:[(evt at: 4) = 0 and:[
		((evt at: 3) bitOr: ((evt at: 5) bitShift: 8)) = interruptKey]])
			 ifTrue:["interrupt key is meta - not reported as event"
					^interruptSemaphore signal].

	"Store the event in the queue if there's any"
	self queueEvent: evt.

	"Update state for InputSensor."
	EventTypeMouse = type ifTrue:[self processMouseEvent: evt].
	EventTypeKeyboard = type ifTrue:[self processKeyboardEvent: evt].
! !

