'From Squeak2.9alpha of 17 July 2000 [latest update: #2660] on 20 September 2000 at 6:57:57 pm'!
"Change Set:		ps2Hacks
Date:			17 September 2000
Author:			Bob Arning

- initial hacking around to get GeeMail printing. 

NOTE: may have altered some previous PostScript printing behavior. Let me know of instances where this is true and I'll fix them."!

Object subclass: #GeePrinter
	instanceVariableNames: 'pasteUp printSpecs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-GeeMail'!
GeePrinter subclass: #GeePrinterPage
	instanceVariableNames: 'pageNumber bounds totalPages '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-GeeMail'!
AlignmentMorphBob1 subclass: #GeePrinterDialogMorph
	instanceVariableNames: 'printSpecs printBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-GeeMail'!
Canvas subclass: #PostscriptCanvas
	instanceVariableNames: 'origin clipRect currentColor currentFont morphLevel gstateStack fontMap usedFonts psBounds topLevelMorph initialScale savedMorphExtent currentTransformation '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Postscript Canvases'!
DSCPostscriptCanvas subclass: #DSCPostscriptCanvasToDisk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Postscript Canvases'!
PrintableEncoder subclass: #PostscriptEncoder
	instanceVariableNames: ''
	classVariableNames: 'MacToPSCharacterMappings '
	poolDictionaries: ''
	category: 'Morphic-Postscript Canvases'!
PostscriptEncoder subclass: #PostscriptEncoderToDisk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Postscript Canvases'!
Object subclass: #PrintSpecifications
	instanceVariableNames: 'landscapeFlag drawAsBitmapFlag '
	classVariableNames: 'DefaultSpecs '
	poolDictionaries: ''
	category: 'Morphic-GeeMail'!
PasteUpMorph subclass: #TextPlusPasteUpMorph
	instanceVariableNames: 'theTextMorph showPageBreaks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-GeeMail'!

!Form methodsFor: 'fileIn/Out' stamp: 'RAA 9/19/2000 18:37'!
store15To24HexBitsOn:aStream

	| buf i |

	"write data for 16-bit form, optimized for encoders writing directly to files to do one single file write rather than 12. I'm not sure I understand the significance of the shifting pattern, but I think I faithfully translated it from the original"

	buf _ String new: 12.
	bits do: [:word | 
		i _ 0.
		"upper pixel"
		buf at: (i _ i + 1) put: ((word bitShift: -27) bitAnd: 15) asHexDigit.
		buf at: (i _ i + 1) put: ((word bitShift: -32) bitAnd: 8) asHexDigit.

		buf at: (i _ i + 1) put: ((word bitShift: -22) bitAnd: 15) asHexDigit.
		buf at: (i _ i + 1) put: ((word bitShift: -27) bitAnd: 8) asHexDigit.

		buf at: (i _ i + 1) put: ((word bitShift: -17) bitAnd: 15) asHexDigit.
		buf at: (i _ i + 1) put: ((word bitShift: -22) bitAnd: 8) asHexDigit.

		"lower pixel"

		buf at: (i _ i + 1) put: ((word bitShift: -11) bitAnd: 15) asHexDigit.
		buf at: (i _ i + 1) put: ((word bitShift: -16) bitAnd: 8) asHexDigit.

		buf at: (i _ i + 1) put: ((word bitShift: -6) bitAnd: 15) asHexDigit.
		buf at: (i _ i + 1) put: ((word bitShift: -11) bitAnd: 8) asHexDigit.

		buf at: (i _ i + 1) put: ((word bitShift: -1) bitAnd: 15) asHexDigit.
		buf at: (i _ i + 1) put: ((word bitShift: -6) bitAnd: 8) asHexDigit.
		aStream print: buf.
		"#( 31 26 21 15 10 5 )  do:[:startBit | ]"
	].! !


!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 11:33'!
allPages

	| pageNumber allPages maxPages |

	maxPages _ 9999.
	pageNumber _ 0.
	allPages _ self pageRectangles collect: [ :rect |
		pageNumber _ pageNumber + 1.
		(self as: GeePrinterPage) pageNumber: pageNumber bounds: rect
	].
	allPages size > maxPages ifTrue: [allPages _ allPages first: maxPages].
	allPages do: [ :each | each totalPages: allPages size].
	^allPages

! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:46'!
bounds

	| w |
	w _ pasteUp width.
	^0@0 extent: w@(w * self hOverW) rounded.! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 12:51'!
doPages

	| dialog |
	(dialog _ GeePrinterDialogMorph new) 
		printSpecs: self printSpecs 
		printBlock: [ :preview :specs |
			preview ifTrue: [self doPrintPreview] ifFalse: [self doPrintToPrinter]
		];
		fullBounds;
		position: Display extent - dialog extent // 2;
		openInWorld

! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 12:59'!
doPrintPreview

	| pageDisplay sz newPage subBounds pic align |

	sz _ (85 @ 110) * 3.
	self printSpecs landscapeFlag ifTrue: [
		sz _ sz transposed
	].
	pageDisplay _ BookMorph new
		color: Color paleYellow;
		borderWidth: 1.
	self allPages withIndexDo: [ :each :index |
		pic _ ImageMorph new image: (each pageThumbnailOfSize: sz).
		align _ AlignmentMorph newColumn
			addMorph: pic;
			borderWidth: 1;
			inset: 0;
			borderColor: Color blue.
		newPage _ pageDisplay 
			insertPageLabel: 'Page ',index printString
			morphs: {align}.
		subBounds _ newPage boundingBoxOfSubmorphs.
		newPage extent: subBounds corner - newPage topLeft + ((subBounds left - newPage left)@0).
	].
	pageDisplay 
		goToPage: 1;
		deletePageBasic;
		position: Display extent - pageDisplay extent // 2;
		openInWorld.
! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 18:08'!
doPrintToPrinter

	"fileName _ ('gee.',Time millisecondClockValue printString,'.eps') asFileName."

	(
		DSCPostscriptCanvasToDisk 
			morphAsPostscript: self 
			rotated: self printSpecs landscapeFlag
	) close
! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/16/2000 17:40'!
fullBounds

	^self bounds! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 11:33'!
fullDrawPostscriptOn: aCanvas

	aCanvas drawPages: self allPages.

! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:46'!
hOverW

	^self printSpecs landscapeFlag ifTrue: [
		8.5 /  11.0
	] ifFalse: [
		11.0 / 8.5
	].
! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:47'!
pageRectangles

	| pageBounds allPageRects |

	pageBounds _ self bounds.
	allPageRects _ OrderedCollection new.
	[pageBounds top <= pasteUp bottom] whileTrue: [
		allPageRects add: pageBounds.
		pageBounds _ pageBounds translateBy: 0 @ pageBounds height.
	].
	^allPageRects
! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/16/2000 17:35'!
pasteUp: x

	pasteUp _ x.! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:33'!
printSpecs

	^printSpecs ifNil: [printSpecs _ PrintSpecifications defaultSpecs].
! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:28'!
printSpecs: aPrintSpecification

	printSpecs _ aPrintSpecification! !

!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 9/16/2000 17:40'!
wantsRoundedCorners

	^false! !


!GeePrinterPage methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 17:41'!
fullDrawPostscriptOn: aCanvas

	| s |
	s _ TextMorph new 
		beAllFont: (TextStyle default fontOfSize: 30);
		contentsAsIs: '   Drawing page ',pageNumber printString,' of ',totalPages printString,'     '.
	s layoutChanged; fullBounds.
	s _ AlignmentMorph newRow
		addMorph: s;
		color: Color yellow.
	s position: Display center - (s width // 2 @ 0).
	World addMorphFront: s.
	World displayWorld.
	printSpecs drawAsBitmapFlag ifTrue: [
		aCanvas paintImage: self pageAsForm at: 0@0
	] ifFalse: [
		aCanvas 
			translateTo: bounds origin negated 
			clippingTo: (0@0 extent: bounds extent) 
			during: [ :c |
				pasteUp fullDrawForPrintingOn: c
			].
	].
	s delete.

! !

!GeePrinterPage methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 16:00'!
pageAsForm

	| f canvas |
	f _ Form extent: bounds extent depth: 16.
	canvas _ f getCanvas.
	canvas fillColor: pasteUp color.
	canvas translateTo: bounds origin negated clippingTo: f boundingBox during: [ :c |
		pasteUp fullDrawForPrintingOn: c
	].
	^f

! !

!GeePrinterPage methodsFor: 'as yet unclassified' stamp: 'RAA 9/16/2000 17:53'!
pageNumber: anInteger bounds: aRect

	pageNumber _ anInteger.
	bounds _ aRect.! !

!GeePrinterPage methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 16:00'!
pageThumbnailOfSize: aPoint

	^self pageAsForm scaledToSize: aPoint

! !

!GeePrinterPage methodsFor: 'as yet unclassified' stamp: 'RAA 9/17/2000 16:51'!
totalPages: x

	totalPages _ x! !


!MatrixTransform2x3 methodsFor: 'composing' stamp: 'RAA 9/20/2000 13:10'!
composedWithLocal: aTransformation
	"Return the composition of the receiver and the local transformation passed in"
	aTransformation isMatrixTransform2x3 ifFalse:[^super composedWithLocal: aTransformation].
	^self composedWithLocal: aTransformation asMatrixTransform2x3 into: self class new! !


!Morph methodsFor: 'printing' stamp: 'RAA 9/18/2000 10:22'!
printSpecs

	| printSpecs |

	printSpecs _ self valueOfProperty: #PrintSpecifications.
	printSpecs ifNil: [
		printSpecs _ PrintSpecifications defaultSpecs.
		self printSpecs: printSpecs.
	].
	^printSpecs! !

!Morph methodsFor: 'printing' stamp: 'RAA 9/18/2000 10:21'!
printSpecs: aPrintSecification

	self setProperty: #PrintSpecifications toValue: aPrintSecification.
! !


!AlansTextPlusMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 10:25'!
printPSToFile

	thePasteUp printer doPages! !


!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 10:43'!
simpleToggleButtonFor: target attribute: attribute help: helpText

	^(EtoyUpdatingThreePhaseButtonMorph checkBox)
		target: target;
		actionSelector: #toggleChoice:;
		arguments: {attribute};
		getSelector: #getChoice:;
		setBalloonText: helpText;
		step

! !


!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 10:50'!
buttonColor

	^color darker! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 10:48'!
buttonNamed: aString action: aSymbol color: aColor help: helpString

	| f col |
	f _ SimpleButtonMorph new
		target: self;
		label: aString;
		color: aColor;
		actionSelector: aSymbol;
		setBalloonText: helpString.
	col _ (self inAColumn: {f}) hResizing: #shrinkWrap.
	^col! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 10:52'!
cancelButton

	^self
		buttonNamed: 'Cancel' 
		action: #doCancel 
		color: self buttonColor 
		help: 'Cancel this printing operation.'! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 11:24'!
doCancel

	self delete! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 11:42'!
doPreview

	self delete.
	printBlock value: true value: printSpecs.! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 11:42'!
doPrint

	self delete.
	printBlock value: false value: printSpecs.! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 17:44'!
getChoice: aSymbol

	aSymbol == #landscapeFlag ifTrue: [^printSpecs landscapeFlag].
	aSymbol == #drawAsBitmapFlag ifTrue: [^printSpecs drawAsBitmapFlag].
! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 11:24'!
initialize

	super initialize.
	vResizing _ hResizing _ #shrinkWrap.
	color _ Color paleYellow.
	borderWidth _ 8.
	borderColor _ color darker.
	inset _ 4.
	self useRoundedCorners.
	printSpecs ifNil: [printSpecs _ PrintSpecifications defaultSpecs].
	self rebuild.
! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 10:51'!
previewButton

	^self
		buttonNamed: 'Preview' 
		action: #doPreview 
		color: self buttonColor 
		help: 'Show a preview of the pages that will be printed on the screen.'! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 10:49'!
printButton

	^self
		buttonNamed: 'Print' 
		action: #doPrint 
		color: self buttonColor 
		help: 'Print me (a PostScript file will be created)'! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 11:26'!
printSpecs: aPrintSpecification printBlock: aTwoArgBlock

	printSpecs _ aPrintSpecification.
	printBlock _ aTwoArgBlock.! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 17:43'!
rebuild

	self removeAllMorphs.
	self addARow: {
		(StringMorph contents: 'PostScript Printing Options') lock.
	}.
	self addARow: {
		self
			simpleToggleButtonFor: self
			attribute: #landscapeFlag
			help: 'Print in landscape mode'.
		(StringMorph contents: ' Landscape') lock.
	}.
	self addARow: {
		self
			simpleToggleButtonFor: self
			attribute: #drawAsBitmapFlag
			help: 'Print as a bitmap'.
		(StringMorph contents: ' Bitmap') lock.
	}.


	self addARow: {
		self printButton.
		self previewButton.
		self cancelButton.
	}.! !

!GeePrinterDialogMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 17:44'!
toggleChoice: aSymbol

	aSymbol == #landscapeFlag ifTrue: [
		printSpecs landscapeFlag: printSpecs landscapeFlag not
	].
	aSymbol == #drawAsBitmapFlag ifTrue: [
		printSpecs drawAsBitmapFlag: printSpecs drawAsBitmapFlag not
	].
! !


!NullEncoder methodsFor: 'accessing' stamp: 'RAA 9/17/2000 11:53'!
close

	^target close.
! !


!PolygonMorph methodsFor: 'drawing' stamp: 'RAA 9/19/2000 17:59'!
drawPostscriptOn: aCanvas 
	"Display the receiver, a spline curve, approximated by straight line segments."

	vertices size < 1 ifTrue: [self error: 'a polygon must have at least one point'].

	closed ifTrue: [
		aCanvas 
			drawPolygon: self getVertices 
			color: self color 
			borderWidth: self borderWidth 
			borderColor: self borderColor.
	] ifFalse: [
		self drawBorderOn: aCanvas.
	].
	self drawArrowsOn: aCanvas.
! !


!PostscriptCanvas methodsFor: 'initialization' stamp: 'RAA 9/18/2000 18:36'!
initializeFontMap
	"Initialize the dictionary mapping message names to actions for C code generation."

	| pairs |
	fontMap _ Dictionary new: 5.
	pairs _ #(
		'Palatino'  'Palatino-Roman'
		'NewYork' 'Helvetica'
		'NewYork-Bold' 'Helvetica-Bold'
		'ComicBold' 'Helvetica-Narrow-Bold'
	).

	1 to: pairs size by: 2 do: [:i |
		fontMap at: (pairs at: i) put: (pairs at: i + 1)].
! !

!PostscriptCanvas methodsFor: 'initialization' stamp: 'RAA 9/20/2000 11:32'!
reset
	super reset.
	origin _ 0@0.							"origin of the top-left corner of this cavas"
	clipRect _ (0@0 corner: 10000@10000).		"default clipping rectangle"
	currentTransformation _ nil.
	morphLevel _ 0.
	gstateStack _ OrderedCollection new.
	self initializeFontMap.
	usedFonts _ Set new.
     initialScale _ 1.0! !

!PostscriptCanvas methodsFor: 'initialization' stamp: 'RAA 9/17/2000 16:08'!
writeSetupForRect:aRect
	target print:'% psBounds origin'; cr.
	target translate: psBounds origin.
	target print:'% flip'; cr.
	target translate: 0 @ 
		(aRect extent y * (EPSCanvas bobsPostScriptHacks ifTrue: [initialScale] ifFalse: [1]));
		scale:initialScale @ initialScale negated;
		print:' [ {true setstrokeadjust} stopped ] pop
[ currenttransfer /exec cvx 1.2 /exp cvx ] cvx bind  settransfer'; cr.



! !

!PostscriptCanvas methodsFor: 'misc canvas' stamp: 'RAA 9/20/2000 11:33'!
preserveStateDuring: aBlock
	| retval saveClip saveTransform |
	target preserveStateDuring: [ :innerTarget |
		saveClip _ clipRect.
		saveTransform _ currentTransformation.
		gstateStack addLast: currentFont.
		gstateStack addLast: currentColor.
		retval _ aBlock value: self.
		currentColor _ gstateStack removeLast.
		currentFont _ gstateStack removeLast.
		clipRect _ saveClip.
		currentTransformation _ saveTransform.
	].
	^ retval
! !

!PostscriptCanvas methodsFor: 'drawing support' stamp: 'RAA 9/20/2000 15:39'!
defineFont: aFont

	| psNameFor alreadyRemapped |

	(usedFonts includes: aFont) ifFalse:[
		psNameFor _ self postscriptFontNameForFont: aFont.
		alreadyRemapped _ usedFonts anySatisfy: [ :each | 
			(self postscriptFontNameForFont: each) = psNameFor
		].
		usedFonts add:aFont.
		" here: define as Type-3 unless we think its available "
		" or, just remap"

		" I had some problems if same font remapped twice"
		alreadyRemapped ifFalse: [target remapFontForSqueak: psNameFor].
	].! !

!PostscriptCanvas methodsFor: 'drawing support' stamp: 'RAA 9/20/2000 14:52'!
transformBy: aDisplayTransform clippingTo: aClipRect during: aBlock smoothing: cellSize

	| retval |
	self comment: 'drawing clipped ' with: aClipRect.
	self comment: 'drawing transformed ' with: aDisplayTransform.
     self preserveStateDuring: [ :inner | 
		currentTransformation ifNil: [
			currentTransformation _ aDisplayTransform
		] ifNotNil: [
			currentTransformation _ currentTransformation composedWithLocal: aDisplayTransform
		].
		aClipRect ifNotNil: [
			clipRect _ aDisplayTransform globalBoundsToLocal: (clipRect intersect: aClipRect) .
			inner rect: aClipRect; clip.
		].
		inner transformBy: aDisplayTransform.
		retval _ aBlock value: inner
	].	
	self comment: 'end of drawing clipped ' with: aClipRect.
	^ retval
! !

!PostscriptCanvas methodsFor: 'drawing' stamp: 'RAA 9/20/2000 16:12'!
fillRectangle: aRectangle fillStyle: aFillStyle
	"Fill the given rectangle."
	| pattern |

	(aFillStyle isKindOf: InfiniteForm) ifTrue: [
		^self infiniteFillRectangle: aRectangle fillStyle: aFillStyle
	].

	aFillStyle isSolidFill ifTrue:[^self fillRectangle: aRectangle color: aFillStyle asColor].

	"We have a very special case for filling with infinite forms"
	(aFillStyle isBitmapFill and:[aFillStyle origin = (0@0)]) ifTrue:[
		pattern _ aFillStyle form.
		(aFillStyle direction = (pattern width @ 0) 
			and:[aFillStyle normal = (0@pattern height)]) ifTrue:[
				"Can use an InfiniteForm"
				^self fillRectangle: aRectangle color: (InfiniteForm with: pattern)].
	].

	"Use a BalloonCanvas instead PROBABLY won't work here"
	self balloonFillRectangle: aRectangle fillStyle: aFillStyle.! !

!PostscriptCanvas methodsFor: 'drawing' stamp: 'RAA 9/20/2000 09:44'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth borderColor: borderColor 

	"since postscript strokes on the line and squeak strokes inside, we need to adjust inwards"
	self 
		setLinewidth: borderWidth; 
	 	rect: (r insetBy: borderWidth / 2);
		fill: fillColor andStroke: borderColor.
! !

!PostscriptCanvas methodsFor: 'drawing' stamp: 'RAA 9/16/2000 16:57'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth topLeftColor: topLeftColor bottomRightColor: bottomRightColor 
 	self setLinewidth:borderWidth; 
	 	rect:r;
		fill:fillColor andStroke:topLeftColor.
	"Now draw bottom right border.
	Note: Must inset this manually!!"
	self comment:'draw inset border'.
	self setLinewidth:0.
	0 to: borderWidth-1 do:[ :offset |
		target comment:'drawing inset: ' with:offset.
		EPSCanvas bobsPostScriptHacks ifTrue: [target newpath].
		self moveto:r topRight + ( offset negated @ offset ); 
			lineto:r bottomRight + ( offset negated @ offset negated );
			lineto:r bottomLeft + ( offset @ offset negated ).
		self stroke:bottomRightColor
	]
! !

!PostscriptCanvas methodsFor: 'drawing' stamp: 'RAA 9/20/2000 16:16'!
infiniteFillRectangle: aRectangle fillStyle: aFillStyle

	self flag: #bob.		"need to fix this"

	"^aFillStyle 
		displayOnPort: (port clippedBy: aRectangle) 
		at: aRectangle origin - origin"
! !

!PostscriptCanvas methodsFor: 'object fileIn' stamp: 'RAA 9/16/2000 19:59'!
converttfocccmgfupti0: varDict tfocccmgfuptis0: smartRefStrm
	"These variables are automatically stored into the new instance #('target' 'filterSelector' 'origin' 'clipRect' 'currentColor' 'currentFont' 'morphLevel' 'gstateStack' 'fontMap' 'usedFonts' 'psBounds' 'topLevelMorph' 'initialScale').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: #('savedMorphExtent')  If a non-nil value is needed, please assign it."
! !

!PostscriptCanvas methodsFor: 'object fileIn' stamp: 'RAA 9/20/2000 11:36'!
converttfocccmgfupti0: varDict tfocccmgfuptisc0: smartRefStrm
	"These variables are automatically stored into the new instance #('target' 'filterSelector' 'origin' 'clipRect' 'currentColor' 'currentFont' 'morphLevel' 'gstateStack' 'fontMap' 'usedFonts' 'psBounds' 'topLevelMorph' 'initialScale').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: #('savedMorphExtent' 'currentTransformation')  If a non-nil value is needed, please assign it."
! !


!DSCPostscriptCanvas methodsFor: 'as yet unclassified' stamp: 'RAA 9/17/2000 12:23'!
pageBBox

	| pageSize offset bbox trueExtent |

	EPSCanvas bobsPostScriptHacks ifTrue: [
		trueExtent _ savedMorphExtent	"this one has been rotated"
	] ifFalse: [
		trueExtent _ psBounds extent
	].
	pageSize _ self defaultImageableArea.
	offset _ ((pageSize extent - trueExtent) / 2 max: 0@0) + self defaultMargin.
	bbox _ offset extent: psBounds extent.

	^bbox! !

!DSCPostscriptCanvas methodsFor: 'as yet unclassified' stamp: 'RAA 9/17/2000 11:51'!
pageOffset
	|  offset  |

	EPSCanvas bobsPostScriptHacks ifTrue: [^0@0].		"seems like we were adding it twice"

	offset _ self pageBBox origin.
	^ (offset x @ offset y).! !

!DSCPostscriptCanvas methodsFor: 'as yet unclassified' stamp: 'RAA 9/17/2000 16:01'!
writePSIdentifierRotated: rotateFlag
	| morphExtent pageExtent scaledBox |

	target	print:'%!!PS-Adobe-2.0'; cr; 
			print:'%%Pages: (atend)'; cr.

	"Define initialScale so that the morph will fit the page rotated or not"
	savedMorphExtent _ morphExtent _ rotateFlag ifTrue: [psBounds extent transposed]
							ifFalse: [psBounds extent].

	pageExtent _ self defaultImageableArea extent asFloatPoint.
	initialScale _ pageExtent x/morphExtent x min: pageExtent y/morphExtent y.
	target print:'% initialScale: '; write:initialScale; cr.
	scaledBox _ self pageBBox rounded.
	target print: '%%BoundingBox: '; write: scaledBox rounded; cr.
	rotateFlag ifTrue: [
		target
			print: '90 rotate'; cr;
			write: self defaultMargin * initialScale;
			space;
			write: (self defaultMargin + scaledBox height * initialScale) negated;
			print: ' translate'; cr
	] ifFalse: [
		target
			write: self defaultMargin * initialScale;
			space;
			write: (self defaultMargin * initialScale);
			print: ' translate'; cr
	].
	target print: '%%EndComments'; cr.

! !


!DSCPostscriptCanvasToDisk methodsFor: 'as yet unclassified' stamp: 'RAA 9/17/2000 16:19'!
morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset

	self reset.
	psBounds _ offset extent: aMorph bounds extent.
	topLevelMorph _ aMorph.
	self writeHeaderRotated: rotateFlag.
	self fullDrawMorph: aMorph.

	^self close

! !


!DSCPostscriptCanvasToDisk class methodsFor: 'as yet unclassified' stamp: 'RAA 9/16/2000 22:14'!
defaultTarget

	^PostscriptEncoderToDisk stream.
! !

!DSCPostscriptCanvasToDisk class methodsFor: 'as yet unclassified' stamp: 'RAA 9/17/2000 16:16'!
morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset

	^self new morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset

! !


!EPSCanvas methodsFor: 'as yet unclassified' stamp: 'RAA 9/17/2000 16:27'!
setupGStateForMorph: aMorph

	target comment: 'setupGState in EPSCanvas'.
	morphLevel == 1 ifTrue: [ 
		EPSCanvas bobsPostScriptHacks ifTrue: [	"needed to print RectangleMorph"
			self writeSetupForRect: aMorph bounds.
			target translate: aMorph bounds origin negated.
		] ifFalse: [
			target translate: aMorph bounds origin negated.
			self writeSetupForRect: aMorph bounds.
		].
	].
! !


!EPSCanvas class methodsFor: 'as yet unclassified' stamp: 'RAA 9/16/2000 16:56'!
bobsPostScriptHacks

	^true! !


!PostscriptCharacterScanner methodsFor: 'as yet unclassified' stamp: 'RAA 9/15/2000 14:39'!
setYFor: anchoredMorph
! !


!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'RAA 9/16/2000 16:57'!
rect: aRect

	EPSCanvas bobsPostScriptHacks ifTrue: [self newpath].
	self
		moveto:aRect topLeft;
		lineto:aRect topRight x @ aRect topRight y;
		lineto:aRect bottomRight x @ aRect bottomRight y;
		lineto:aRect bottomLeft x @ aRect bottomLeft y;
		closepath.
! !


!PostscriptEncoder class methodsFor: 'configuring' stamp: 'RAA 9/19/2000 23:07'!
clearCharacterMappings

	MacToPSCharacterMappings _ nil.! !

!PostscriptEncoder class methodsFor: 'configuring' stamp: 'RAA 9/19/2000 23:06'!
macToPSCharacterChart
	"mac char code, PS char code"
	^#(
		(128 999)  ""
		(129 999)  ""
		(130 999)  ""
		(131 999)  ""
		(132 999)  ""
		(133 999)  ""
		(134 999)  ""
		(135 999)  ""
		(136 999)  ""
		(137 999)  ""
		(138 999)  ""
		(139 999)  ""
		(140 999)  ""
		(141 999)  ""
		(142 999)  ""
		(143 999)  ""
		(144 999)  ""
		(145 999)  ""
		(146 999)  ""
		(147 999)  ""
		(148 999)  ""
		(149 999)  ""
		(150 999)  ""
		(151 999)  ""
		(152 999)  ""
		(153 999)  ""
		(154 999)  ""
		(155 999)  ""
		(156 999)  ""
		(157 999)  ""
		(158 999)  ""
		(159 999)  ""
		(160 999)  ""
		(161 202)  ""
		(162 162)  ""
		(163 163)  ""
		(164 167)  ""
		(165 183)  ""
		(166 182)  ""
		(167 251)  ""
		(168 999)  ""
		(169 999)  ""
		(170 999)  ""
		(171 999)  ""
		(172 999)  ""
		(173 999)  ""
		(174 225)  ""
		(175 999)  ""
		(176 999)  ""
		(177 999)  ""
		(178 999)  ""
		(179 999)  ""
		(180 165)  ""
		(181 999)  ""
		(182 999)  ""
		(183 999)  ""
		(184 999)  ""
		(185 999)  ""
		(186 999)  ""
		(187 227)  ""
		(188 235)  ""
		(189 999)  ""
		(190 241)  ""
		(191 999)  ""
		(192 191)  ""
		(193 166)  ""
		(194 999)  ""
		(195 999)  ""
		(196 999)  ""
		(197 999)  ""
		(198 999)  ""
		(199 171)  ""
		(200 187)  ""
		(201 188)  ""
		(202 999)  ""
		(203 999)  ""
		(204 999)  ""
		(205 999)  ""
		(206 234)  ""
		(207 250)  ""
		(208 999)  ""
		(209 999)  ""
		(210 999)  ""
		(211 999)  ""
		(212 999)  ""
		(213 999)  ""
		(214 999)  ""
		(215 999)  ""
		(216 999)  ""
		(217 999)  ""
		(218 999)  ""
		(219 999)  ""
		(220 999)  ""
		(221 999)  ""
		(222 999)  ""
		(223 999)  ""
		(224 999)  ""
		(225 999)  ""
		(226 999)  ""
		(227 999)  ""
		(228 999)  ""
		(229 999)  ""
		(230 999)  ""
		(231 999)  ""
		(232 999)  ""
		(233 999)  ""
		(234 999)  ""
		(235 999)  ""
		(236 999)  ""
		(237 999)  ""
		(238 999)  ""
		(239 999)  ""
		(240 999)  ""
		(241 999)  ""
		(242 999)  ""
		(243 999)  ""
		(244 999)  ""
		(245 999)  ""
		(246 999)  ""
		(247 999)  ""
		(248 999)  ""
		(249 999)  ""
		(250 999)  ""
		(251 999)  ""
		(252 999)  ""
		(253 999)  ""
		(254 999)  ""
		(255 999)  ""
	)! !

!PostscriptEncoder class methodsFor: 'configuring' stamp: 'RAA 9/19/2000 18:05'!
mapMacStringToPS: aString

	| copy val newVal |
	MacToPSCharacterMappings ifNil: [
		MacToPSCharacterMappings _ Array new: 256.
		self macToPSCharacterChart do: [ :pair |
			pair second = 999 ifFalse: [MacToPSCharacterMappings at: pair first put: pair second]
		].
	].
	copy _ aString copy.
	copy withIndexDo: [ :ch :index |
		(val _ ch asciiValue) > 127 ifTrue: [
			(newVal _ MacToPSCharacterMappings at: val) ifNotNil: [
				copy at: index put: newVal asCharacter
			].
		].
	].
	^copy! !


!PostscriptEncoderToDisk class methodsFor: 'as yet unclassified' stamp: 'RAA 9/16/2000 23:03'!
stream

	^self new initWithTarget: (
		FileStream fileNamed: 'xxx',Time millisecondClockValue printString,'.eps'
	)
! !


!PrintSpecifications methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 17:06'!
drawAsBitmapFlag

	^drawAsBitmapFlag ifNil: [false]! !

!PrintSpecifications methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 17:07'!
drawAsBitmapFlag: aBoolean

	drawAsBitmapFlag _ aBoolean! !

!PrintSpecifications methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:24'!
initialize

	landscapeFlag _ false.
! !

!PrintSpecifications methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 17:06'!
landscapeFlag

	^landscapeFlag ifNil: [false]! !

!PrintSpecifications methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:24'!
landscapeFlag: aBoolean

	landscapeFlag _ aBoolean! !


!PrintSpecifications class methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:29'!
defaultSpecs

	DefaultSpecs ifNil: [DefaultSpecs _ self new].
	^DefaultSpecs copy! !

!PrintSpecifications class methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:29'!
defaultSpecs: aPrintSpecification

	DefaultSpecs _ aPrintSpecification! !

!PrintSpecifications class methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 09:24'!
new

	^super new initialize! !


!String methodsFor: 'converting' stamp: 'RAA 9/19/2000 17:00'!
asPostscript

	| temp |
	temp _ self asString copyReplaceAll: '(' with: '\('.
	temp _ temp copyReplaceAll: ')' with: '\)'.
	temp _ temp copyReplaceAll: '
' 
			with: ''.
	^ PostscriptEncoder mapMacStringToPS: temp! !


!TextPlusMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 16:27'!
linkNewlyDroppedMorph: aMorph

	| ed para lineToUse |

	ed _ self editor.
	para _ self paragraph.
	lineToUse _ para lines detect: [ :each | each bottom > aMorph top] ifNone: [para lines last].
	ed selectFrom: lineToUse first to: lineToUse last.
	self addAlansAnchorFor: aMorph.

! !


!TextPlusPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/19/2000 16:13'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: NewHandleMorph) ifTrue: [^self].
	self addMorph: aMorph.
	theTextMorph linkNewlyDroppedMorph: aMorph! !

!TextPlusPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 15:55'!
drawOn: aCanvas

	| clip rects |
	super drawOn: aCanvas.
	showPageBreaks == false ifTrue: [^self].

	clip _ aCanvas clipRect.
	rects _ self printer pageRectangles.
	rects do: [ :each |
		each bottom > clip bottom ifTrue: [^self].
		aCanvas 
			fillRectangle: (self left @ each bottom corner: self right @ each bottom + 1) 
			color: Color red
	].! !

!TextPlusPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 15:57'!
fullDrawForPrintingOn: aCanvas

	| save |

	save _ showPageBreaks.
	showPageBreaks _ false.
	self fullDrawOn: aCanvas.
	showPageBreaks _ save
! !

!TextPlusPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 15:54'!
initialize

	super initialize.
	showPageBreaks _ true.! !

!TextPlusPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/18/2000 10:25'!
printer

	^GeePrinter new 
		pasteUp: self;
		printSpecs: self printSpecs! !

!TextPlusPasteUpMorph methodsFor: 'object fileIn' stamp: 'RAA 9/18/2000 16:00'!
convertbosfcebbpmcpbttliairfidcuwwgt0: varDict bosfcebbpmcpbttliairfidcuwwgts0: smartRefStrm
	"These variables are automatically stored into the new instance #('bounds' 'owner' 'submorphs' 'fullBounds' 'color' 'extension' 'borderWidth' 'borderColor' 'presenter' 'model' 'cursor' 'padding' 'backgroundMorph' 'turtleTrailsForm' 'turtlePen' 'lastTurtlePositions' 'isPartsBin' 'autoLineLayout' 'indicateCursor' 'resizeToFit' 'fileName' 'isStackLike' 'dataInstances' 'currentDataInstance' 'userFrameRectangle' 'wantsMouseOverHalos' 'worldState' 'griddingOn' 'theTextMorph').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: #('showPageBreaks')  If a non-nil value is needed, please assign it."
! !

EToyCommunicatorMorph removeSelector: #simpleToggleButtonFor:attribute:help:!
"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

PostscriptEncoder clearCharacterMappings!

