'From Squeak 2.2beta of Sept 16, 1998 on 16 September 1998 at 9:38:23 am'!

!ChangeSet methodsFor: 'fileIn/Out' stamp: 'di 9/16/1998 09:36'!
summaryString
	"Answer the string summarizing this changeSet"
	| ps s2 date author line |
	^ String streamContents:
		[:s |
		s nextPutAll: self name.
		(ps _ self preambleString)
			ifNil: [s cr]
			ifNotNil:
			[s2 _ ReadStream on: ps.
			s2 match: 'Date:		'.  date _ s2 upTo: Character cr.
			s2 match: 'Author:			'.  author _ s2 upTo: Character cr.
			s nextPutAll: ' -- '; nextPutAll: author; nextPutAll: ' -- '; nextPutAll: date; cr.
			[s2 atEnd] whileFalse:
				[line _ s2 upTo: Character cr.
				(line isEmpty or: [line = '"']) ifFalse: [s nextPutAll: line; cr]]]].
"
To summarize all changeSets in this image...
(FileStream newFileNamed: 'ChangeSummaries.txt') nextPutAll:
(String streamContents:
	[:s | ChangeSorter gatherChangeSets do:
		[:cs | s nextPutAll: cs summaryString; cr]])
"! !


!StandardScriptingSystem methodsFor: 'utilities' stamp: 'di 9/16/1998 00:38'!
prepareForExternalReleaseNamed: aReleaseName
	"ScriptingSystem prepareForExternalReleaseNamed: '2.2Beta'"

	EToySystem stripMethodsForExternalRelease.

	self class compile: 'guessDOLProxy
	"deleted for external release"' classified: 'stripped'.

	ScriptingSystem saveFormsToFileNamed: aReleaseName, '.Dis.Forms'.
	ScriptingSystem stripGraphicsForExternalRelease.
	ScriptingSystem cleanupsForRelease.
	ScreenController initialize.
! !


!SystemDictionary methodsFor: 'housekeeping' stamp: 'di 9/16/1998 09:38'!
makeExternalRelease		"Smalltalk makeExternalRelease"
	(self confirm: self version , '
Is this the correct version designation?
If not, choose no, and fix it.') ifFalse: [^ self].
	(Object classPool at: #DependentsFields) size > 1 ifTrue: [self halt].
	Browser initialize.
	Undeclared isEmpty ifFalse: [self halt].
	Smalltalk garbageCollect.
	Smalltalk obsoleteClasses isEmpty ifFalse: [self halt].
	Display newDepth: 8.
	Project allInstancesDo: [:p | p displayDepth: 8].
	Utilities removeDisney.
	ScriptingSystem prepareForExternalReleaseNamed: 'Squeak2.2beta'.
	StandardScriptingSystem removeSelector: #serverUrls.
	EToySystem class removeSelector: #serverUrls.
	ServerDirectory removeServerNamed: 'UpdatesAtDOL'.
	ServerDirectory removeServerNamed: 'UpdatesAtWebPage'.
	#(Helvetica Palatino ComicAll) do:
		[:k | TextConstants removeKey: k].
	SystemDictionary removeSelector: #makeExternalRelease.
	Symbol rehash.
	self halt: 'Ready to condense sources'.
	Smalltalk condenseSources! !


HtmlFormatter removeSelector: #preformatted:!
