'From Squeak2.9alpha of 13 June 2000 [latest update: #2869] on 12 October 2000 at 5:20:53 pm'!
"Change Set:		TwoMoreFixes
Date:			12 October 2000
Author:			Andreas Raab

Two more fixes. Make the control menu pop up for the outermost morph in the innermost world (not the outermost morph in the innermost pasteup) and fix a problem with halos after one of the recent changes. Since mouse events resulting in drops are no longer dispatched separately, the corresponding #mouseUp never reached the duplicate or grab handle after the hand dropped the morph in question. This results in a lonely handle after completing the grab/dup operation."!


!Morph methodsFor: 'meta-actions' stamp: 'ar 10/12/2000 17:07'!
handlerForMetaMenu: evt
	"Return the prospective handler for invoking the meta menu. By default, the top-most morph in the innermost world gets this menu"
	self isWorldMorph ifTrue:[^self].
	evt handler ifNotNil:[evt handler isWorldMorph ifTrue:[^self]].
	^nil! !


!HaloMorph methodsFor: 'events' stamp: 'ar 10/12/2000 17:12'!
handleListenEvent: anEvent
	"We're listen for possible drop events here to add back those handles after a dup/grab operation"
	(anEvent isMouse and:[anEvent isMove not]) ifFalse:[^self]. "not interested"
	anEvent hand removeMouseListener: self. "done listening"
	self addHandles. "and get those handles back"! !

!HaloMorph methodsFor: 'private' stamp: 'ar 10/12/2000 17:12'!
doDup: evt with: dupHandle
	"Ask hand to duplicate my target."

	(target isKindOf: SelectionMorph) ifTrue:
		[^ target doDup: evt fromHalo: self handle: dupHandle].
	self setTarget: (target duplicateMorph: evt).
	self removeAllHandlesBut: dupHandle.
	evt hand addMouseListener: self. "Listen for the drop"! !

!HaloMorph methodsFor: 'private' stamp: 'ar 10/12/2000 17:13'!
doGrab: evt with: grabHandle
	"Ask hand to grab my target."

	self removeAllHandlesBut: grabHandle.  "remove all other handles"
	evt hand grabMorph: target.
	evt hand addMouseListener: self. "Listen for the drop"! !

