'From Squeak2.9alpha of 12 June 2000 [latest update: #3049] on 29 November 2000 at 8:02:22 pm'!
"Change Set:		benchmarkTweaks
Date:			29 November 2000
Author:			Dan Ingalls

A couple of tweaks that make it more convenient to run, eg, FreeCell or the InterpreterSimulator as performance benchmarks.
"!


!FreeCellBoard methodsFor: 'initialization' stamp: 'di 11/29/2000 18:50'!
pickGame: aSeedOrNil
	| sorted msg |
	cardDeck _ PlayingCardDeck newDeck.
	aSeedOrNil == 1
	ifTrue:
		["Special case of game 1 does a time profile playing the entire (trivial) game."
		sorted _ cardDeck submorphs asSortedCollection: [ :a :b | a cardNumber >= b cardNumber].
		cardDeck
			removeAllMorphs;
			addAllMorphs: sorted.
		self resetBoard.
		self world doOneCycle.
		Utilities informUser: 'Game #1 is a special case
for performance analysis' during:
			[msg _ self world firstSubmorph.
			msg align: msg topRight with: owner bottomRight.
			MessageTally spyOn: [sorted last owner doubleClickOnCard: sorted last]]]
	ifFalse:
		[aSeedOrNil ifNotNil:[cardDeck seed: aSeedOrNil].
		cardDeck shuffle.
		self resetBoard].
	! !


!InterpreterSimulator methodsFor: 'testing' stamp: 'di 11/29/2000 10:26'!
profile: nBytecodes
	"(InterpreterSimulator new openOn: 'clonex.image') profile: 60000"
	Transcript clear.
	byteCount _ 0.
	MessageTally spyOn: [self runForNBytes: nBytecodes].
	self close! !

!InterpreterSimulator methodsFor: 'testing' stamp: 'di 11/29/2000 10:25'!
profileSends: nBytecodes
	"(InterpreterSimulator new openOn: 'clonex.image') profileSends: 5000"
	MessageTally tallySendsTo: self
		inBlock: [self runForNBytes: nBytecodes]
		showTree: true.
	self close! !

!InterpreterSimulator methodsFor: 'testing' stamp: 'di 11/29/2000 10:24'!
runForNBytes: nBytecodes
	byteCount _ 0.
	self internalizeIPandSP.
	self fetchNextBytecode.
	[byteCount < nBytecodes] whileTrue:
		[self dispatchOn: currentBytecode in: BytecodeTable.
		byteCount _ byteCount + 1].
	self externalizeIPandSP.
! !

