'From Squeak 2.2beta of Sept 16, 1998 on 23 September 1998 at 9:20:15 am'!
"Change Set:		minorFixups-sw
Date:			23 September 1998
Author:			Scott Wallace

Makes Inspector class openAsMorphOn:withEvalPane:withLabel:valueViewClass: honor the requested label, with the result (among other things) that the Preferences inspector shows the desired title when opened in Morphic.

Fixes it such that the menu titles for selector menus in Morphic are absent rather than reading 'nil' when the showTimeStampsInMenuTitles pref is false"!


!Inspector class methodsFor: 'instance creation' stamp: 'sw 9/23/1998 08:16'!
openAsMorphOn: anObject
	^ self openAsMorphOn: anObject withLabel: anObject defaultLabelForInspector! !

!Inspector class methodsFor: 'instance creation' stamp: 'sw 9/23/1998 08:30'!
openAsMorphOn: anObject withEvalPane: withEval withLabel: label valueViewClass: valueViewClass
	"Note: for now, this always adds an eval pane, and ignores the valueViewClass"

	(self openAsMorphOn: anObject withLabel: label) openInWorld! !

!Inspector class methodsFor: 'instance creation' stamp: 'sw 9/23/1998 08:16'!
openAsMorphOn: anObject withLabel: aLabel
	"(Inspector openAsMorphOn: SystemOrganization) openInMVC"
	| window inspector |
	inspector _ self inspect: anObject.
	window _ (SystemWindow labelled: aLabel)
				model: inspector.

	window addMorph: (PluggableListMorph on: inspector list: #fieldList
				selected: #selectionIndex changeSelected: #toggleIndex:
				menu: ((inspector isMemberOf: DictionaryInspector)
						ifTrue: [#dictionaryMenu:]
						ifFalse: [#fieldListMenu:])
				keystroke: #inspectorKey:from:)
		frame: (0@0 corner: 0.3@0.7).
	window addMorph: (PluggableTextMorph on: inspector text: #contents accept: #accept:
				readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
		frame: (0.3@0 corner: 1@0.7).
	window addMorph: ((PluggableTextMorph on: inspector text: #trash accept: #trash:
				readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
					askBeforeDiscardingEdits: false)
		frame: (0@0.7 corner: 1@1).

	window position: 16@0.  "Room for scroll bar."
	^ window! !


!ScrollPane methodsFor: 'menu' stamp: 'sw 9/23/1998 08:47'!
getMenu: shiftKeyState
	"Answer the menu for this text view, supplying an empty menu to be filled in. If the menu selector takes an extra argument, pass in the current state of the shift key."
	| menu aMenu aTitle |
	getMenuSelector == nil ifTrue: [^ nil].
	menu _ MenuMorph new defaultTarget: model.
	aTitle _ getMenuTitleSelector ifNotNil: [model perform: getMenuTitleSelector].
	getMenuSelector numArgs = 1 ifTrue:
		[aMenu _ model perform: getMenuSelector with: menu.
		aTitle ifNotNil:  [aMenu addTitle: aTitle].
		^ aMenu].
	getMenuSelector numArgs = 2 ifTrue:
		[aMenu _ model perform: getMenuSelector with: menu with: shiftKeyState.
		aTitle ifNotNil:  [aMenu addTitle: aTitle].
		^ aMenu].
	^ self error: 'The getMenuSelector must be a 1- or 2-keyword symbol'! !


