'From Squeak2.9alpha of 17 July 2000 [latest update: #3324] on 29 January 2001 at 3:19:13 pm'!
"Change Set:		listColorFix
Date:			29 January 2001
Author:			Bob Arning

A problem has been noted with recent changes to SystemWindows: since some of the lists are now inside AlignmentMorphs, they are not automatically being set to the window color. This caused some anomalies in the color chosen for higlighting the selected item, especially in 8-bit mode. This chane set modifies the color selection process to skip over transparent morphs to find the owner with a real color. Also, for dark-colored panes, the highlighting color is lighter rahter than darker for better contrast. Thanks to Robert Hirschfeld for pointing this out"!


!PluggableListMorph methodsFor: 'drawing' stamp: 'RAA 1/29/2001 15:14'!
drawOn: aCanvas
	| colorToFillWith areaToFill next |

	super drawOn: aCanvas.
	selectedMorph ifNil: [^self].
	colorToFillWith _ color.
	next _ self.
	[colorToFillWith isTransparent and: [(next _ next owner) notNil]] whileTrue: [
		colorToFillWith _ next color.
	].
	colorToFillWith _ colorToFillWith luminance < 0.5 ifTrue: [
		colorToFillWith muchLighter
	] ifFalse: [
		colorToFillWith darker
	].

	areaToFill _ ((scroller transformFrom: self) localBoundsToGlobal: selectedMorph bounds)
					intersect: scroller bounds.
	aCanvas fillRectangle: areaToFill color: colorToFillWith.
! !

