'From Squeak3.1alpha of 5 February 2001 [latest update: #3545] on 7 February 2001 at 10:57:03 pm'!
"Change Set:		trashTweaks-sw
Date:			7 February 2001
Author:			Scott Wallace

Opening up a trash-can that resided in a flap had become broken with the recent change that made double-click the gesture for opening the trash.  This is now repaired in this update -- the double-click now opens the Scraps-Book squarely in the center of the screen, right on the desktop.

Balloon help for the trashcan is improved also.

Standard left (Squeak) flap modified such that it again has pop-open/pop-closed behavior on *drag-over*.  This is handy for throwing away something that your hand is carrying -- just drag it over the Squeak tab, then the flap will pop open, and you can drop the unwanted item onto the trashcan found at the bottom of that flap.  This change will not take effect until flaps are reinitialized however."!


!PasteUpMorph methodsFor: 'world menu' stamp: 'sw 2/7/2001 20:10'!
openScrapsBook: evt
	"Open up the Scraps book in the center of the screen"

	evt hand world addMorphCentered: Utilities scrapsBook! !


!TrashCanMorph methodsFor: 'initialization' stamp: 'sw 2/7/2001 20:18'!
initialize
	"Initialize the receiver's graphics, name, and balloon-help"

	super initialize.
	self image: TrashPicOn;
		offImage: TrashPic;
		pressedImage: TrashPicOn.
	self setNameTo: 'Trash'.
	self setBalloonText:
'To remove an object, drop it on any trash can. To view, and maybe retrieve, items that have been thrown away, double-click on any trash-can.  Things are retained in the trash-can if the "preserveTrash" preference is set, otherwise they are purged immediately'.
! !


!Utilities class methodsFor: 'flaps' stamp: 'sw 2/7/2001 20:20'!
initializeStandardFlaps
	"Initialize the standard default out-of-box set of global flaps. This method creates them and places them in my class variable #FlapTabs, but does not itself get them displayed."

	FlapTabs _ OrderedCollection new.
	FlapTabs add: self standardLeftFlap.
	FlapTabs add: self standardBottomFlap.
	FlapTabs add: self standardRightFlap.
	FlapTabs do:
		[:aFlapTab | 
			aFlapTab setToPopOutOnMouseOver: false].

	^ FlapTabs

"Utilities reinstateDefaultFlaps"! !

