'From Squeak 2.2 of Sept 23, 1998 on 13 October 1998 at 12:46:04 pm'!
"Change Set:		watcherFormat-sw
Date:			13 October 1998
Author:			Scott Wallace

Adds menu items allowing specification of number of decimal places, font size, and font family to the UpdatingStringMorph, used in watchers and viewers.

Also, removes the 'tear-off-value-tile' feature I added in August 1998 -- turns out I had misunderstood Alan's request.  The watchers turned out to be the solution to his wishes, but I never until now got around to ripping out the falsely-interpreted path"!


!Morph methodsFor: 'scripting' stamp: 'sw 10/6/1998 17:10'!
tearOffTile
	^ self assuredPlayer tearOffTileForSelf! !


!StrikeFont methodsFor: 'accessing' stamp: 'sw 10/5/1998 16:38'!
textStyle
	^ Utilities actualTextStyles detect:
		[:aStyle | aStyle fontArray includes: self] ifNone: [nil]! !


!UpdatingStringMorph methodsFor: 'target access' stamp: 'sw 10/6/1998 08:02'!
readFromTarget

	| v |
	((target == nil) or: [getSelector == nil]) ifTrue: [^ contents].
	v _ target scriptPerformer perform: getSelector.
	lastValue _ v.
	format = #string ifTrue: [^ v].
	(format = #default and: [v isNumber]) ifTrue:
		[v isInteger ifTrue: [^ v asInteger printString].
		(v isKindOf: Float) ifTrue: [^ (v roundTo: self floatPrecision) printString]].
	^ v printString
! !

!UpdatingStringMorph methodsFor: 'editing' stamp: 'sw 10/6/1998 08:26'!
addCustomMenuItems: menu hand: aHandMorph

	| prefix |
	super addCustomMenuItems: menu hand: aHandMorph.
	prefix _ self growable
		ifTrue:
			['stop']
		ifFalse:
			['start'].
	menu add: prefix, ' being growable' action: #toggleGrowability.
	menu add: 'decimal places...' action: #setPrecision.
	menu add: 'font size...' action: #setFontSize.
	menu add: 'font style...' action: #setFontStyle! !

!UpdatingStringMorph methodsFor: 'editing' stamp: 'sw 10/6/1998 17:34'!
setFontSize
	| sizes reply family aPair |
	family _ font ifNil: [TextStyle default] ifNotNil: [font textStyle].
	family ifNil: [family _ TextStyle default].  "safety net -- this line SHOULD be unnecessary now"
	sizes _ 	family fontNamesAndSizes collect: [:aString |
		aPair _ aString findTokens: ' '.
		aPair second asNumber].
	reply _ (SelectionMenu labelList: (sizes collect: [:s | s printString]) selections: sizes) startUp.
	reply ifNotNil:
		[self font: (family fontAt: (sizes indexOf: reply))]! !

!UpdatingStringMorph methodsFor: 'editing' stamp: 'sw 10/6/1998 17:42'!
setFontStyle
	| aList reply style |
	aList _ (TextConstants select: [:anItem | anItem isKindOf: TextStyle])
			keys asOrderedCollection.
	reply _ (SelectionMenu labelList: aList selections: aList) startUp.
	reply ~~ nil ifTrue:
		[(style _ TextStyle named: reply) ifNil: [self beep. ^ true].
		self font: (style fontArray at: 2)]! !

!UpdatingStringMorph methodsFor: 'editing' stamp: 'sw 10/5/1998 15:31'!
setPrecision
	| aList aMenu reply |
	aList _ #('0' '1' '2' '3' '4' '5').
	aMenu _ SelectionMenu labels: aList selections: aList.
	reply _ aMenu startUpWithCaption: 'How many decimal places?'.
	reply ifNotNil:
		[self floatPrecision:
			(#(1 0.1 0.01 0.001 0.0001 0.00001 0.000001) at: (aList indexOf: reply))]! !


!Utilities class methodsFor: 'summer97 additions' stamp: 'sw 10/6/1998 17:41'!
actualTextStyles   "Utilities actualTextStyles"
	| aCollection |
	aCollection _ OrderedCollection new.
	(TextConstants select: [:anItem | anItem isKindOf: TextStyle]) do:
		[:aStyle | aCollection add: aStyle].
	^ aCollection

! !


Morph removeSelector: #valueAsConstant!
StringMorph removeSelector: #valueAsConstant!
UpdatingRectangleMorph removeSelector: #valueAsConstant!
UpdatingStringMorph removeSelector: #valueAsConstant!
