'From Squeak3.1alpha of 5 February 2001 [latest update: #3689] on 22 February 2001 at 2:32:28 pm'!
"Change Set:		appearance6
Date:			22 February 2001
Author:			Bob Arning

Add control for drop shadow offset

Fix setting and resetting color of SystemWindow"!


!ObjectPropertiesMorph methodsFor: 'as yet unclassified' stamp: 'RAA 2/22/2001 09:26'!
adjustTargetShadowOffset: aFractionalPoint

	targetMorph changed; layoutChanged.
	targetMorph shadowOffset: (aFractionalPoint * 4) rounded.
	targetMorph changed; layoutChanged.
! !

!ObjectPropertiesMorph methodsFor: 'as yet unclassified' stamp: 'RAA 2/22/2001 14:27'!
numberOneColor: aColor

	targetMorph fillStyle isGradientFill ifFalse: [
		^(targetMorph isKindOf: SystemWindow) ifTrue: [
			targetMorph setWindowColor: aColor
		] ifFalse: [
			targetMorph fillStyle: aColor
		]
	].
	targetMorph fillStyle firstColor: aColor forMorph: targetMorph hand: nil
! !

!ObjectPropertiesMorph methodsFor: 'as yet unclassified' stamp: 'RAA 2/22/2001 14:31'!
rebuild

	self removeAllMorphs.
	self addARow: {
		self lockedString: 'Properties for ',targetMorph name.
	}.
	self addARow: {
		self inAColumn: {
			self paneForCornerRoundingToggle.
			self paneForStickinessToggle.
			self paneForLockedToggle.
		}.
	}.

	self addARow: {
		self paneForMainColorPicker.
		self paneFor2ndGradientColorPicker.
	}.
	self addARow: {
		self paneForBorderColorPicker.
		self paneForShadowColorPicker.
	}.

	self addARow: {
		self 
			buttonNamed: 'Accept' action: #doAccept color: color lighter 
			help: 'keep changes made and close panel'.
		self 
			buttonNamed: 'Cancel' action: #doCancel color: color lighter 
			help: 'cancel changes made and close panel'.
	}.

	revertSteps _ Dictionary new.
	"revertSteps at: #fillStyle: put: targetMorph fillStyle."
	(targetMorph isKindOf: SystemWindow) ifTrue: [
		revertSteps at: #setWindowColor: put: targetMorph paneColorToUse
	].
	revertSteps at: #hasDropShadow: put: targetMorph hasDropShadow.
	revertSteps at: #shadowColor: put: targetMorph shadowColor.
	(targetMorph respondsTo: #borderColor:) ifTrue: [
		revertSteps at: #borderColor: put: targetMorph borderColor.
	].

	revertSteps at: #borderWidth: put: targetMorph borderWidth.
	revertSteps at: #cornerStyle: put: targetMorph cornerStyle.
	revertSteps at: #cornerStyle: put: targetMorph cornerStyle.
	revertSteps at: #sticky: put: targetMorph isSticky.
	revertSteps at: #lock: put: targetMorph isLocked.
! !

!ObjectPropertiesMorph methodsFor: 'panes' stamp: 'RAA 2/22/2001 09:23'!
paneForShadowColorPicker

	^self 
		inAColumn: {
			(self inAColumn: {
				self colorPickerFor: targetMorph getter: #shadowColor setter: #shadowColor:.
				self paneForShadowOffset.
			}
			named: #pickerForShadowColor) layoutInset: 0.
			self inAColumn: {
				self paneForDropShadowToggle.
			} 
		}

! !

!ObjectPropertiesMorph methodsFor: 'panes' stamp: 'RAA 2/22/2001 09:21'!
paneForShadowOffset

	^(self inARow: {
		self
			buildFakeSlider: 'Offset' 
			selector: #adjustTargetShadowOffset:
			help: 'Drag in here to change the offset of the shadow'
	}) hResizing: #shrinkWrap

! !

