'From Squeak3.1alpha of 7 February 2001 [latest update: #3738] on 27 February 2001 at 6:39:24 am'!
"Change Set:		compoundTile-sw
Date:			26 February 2001
Author:			Scott Wallace

Fixes some appearance bugs that slipped into the classic tile system, involving compound tiles (the test/yes/no complexes).

Also strips out some dead ScriptEditorMorph code"!


!CompoundTileMorph methodsFor: 'initialization' stamp: 'sw 2/27/2001 06:31'!
initialize

	| r |
	super initialize.
	self color: Color orange muchLighter.
	self borderWidth: 1.
	self layoutInset: 2.
	self listDirection: #topToBottom.
	self hResizing: #spaceFill; vResizing: #shrinkWrap; cellInset: (0 @ 1); minCellSize: (200@14).

	r _ AlignmentMorph newRow color: color; layoutInset: 0.
	r setProperty: #demandsBoolean toValue: true.
	r addMorphBack: (Morph new color: color; extent: 2@5).  "spacer"
	r addMorphBack: (StringMorph new contents: 'Test').
	r addMorphBack: (Morph new color: color; extent: 5@5).  "spacer"
	r addMorphBack: (testPart _ BooleanScriptEditor new borderWidth: 0; layoutInset: 1).
	testPart color: Color transparent.
	testPart hResizing: #spaceFill..
	self addMorphBack: r.

	r _ AlignmentMorph newRow color: color; layoutInset: 0.
	r addMorphBack: (Morph new color: color; extent: 30@5).  "spacer"
	r addMorphBack: (StringMorph new contents: 'Yes').
	r addMorphBack: (Morph new color: color; extent: 5@5).  "spacer"
	r addMorphBack: (yesPart _ ScriptEditorMorph new borderWidth: 0; layoutInset: 2).
	yesPart hResizing: #spaceFill.
	yesPart color: Color transparent.
	self addMorphBack: r.

	r _ AlignmentMorph newRow color: color; layoutInset: 0.
	r addMorphBack: (Morph new color: color; extent: 35@5).  "spacer"
	r addMorphBack: (StringMorph new contents: 'No').
	r addMorphBack: (Morph new color: color; extent: 5@5).  "spacer"
	r addMorphBack: (noPart _ ScriptEditorMorph new borderWidth: 0; layoutInset: 2).
	noPart hResizing: #spaceFill.
	noPart color: Color transparent.
	self addMorphBack: r.
	self bounds: self fullBounds! !


!TilePadMorph methodsFor: 'miscellaneous' stamp: 'sw 2/26/2001 02:51'!
initialize
	"Initialize the receiver.  Give it a table layout policy"

	super initialize.
	self changeTableLayout! !

ScriptEditorMorph removeSelector: #addTextualScript:!
ScriptEditorMorph removeSelector: #appendTileRows:!
ScriptEditorMorph removeSelector: #browseScripts!
ScriptEditorMorph removeSelector: #colorWhenRunning!
ScriptEditorMorph removeSelector: #labelForButton!
ScriptEditorMorph removeSelector: #scriptName:!
ScriptEditorMorph removeSelector: #scriptName:phrase:!
ScriptEditorMorph removeSelector: #startOutEmptyForScriptName:!
ScriptEditorMorph removeSelector: #titleMorph!
