'From Squeak3.1alpha of 28 February 2001 [latest update: #3786] on 5 March 2001 at 1:59:53 pm'!
"Change Set:		reorderCards-sw
Date:			5 March 2001
Author:			Scott Wallace

Stopgap measure -- adds commands to Stack menu allowing a card to be moved forward or backward in the stack's ordering -- either one position at a time, or all the way to the front or back of the entire stack.  Someday we will need a proper card sorter, but that does not at all straightforwardly fall out from the existing BookPageSorter design."!


!StackMorph methodsFor: 'menu' stamp: 'sw 3/5/2001 13:18'!
invokeBookMenu
	"Invoke the book's control panel menu."

	| aMenu |
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addTitle: 'Stack'.
	aMenu addStayUpItem.
	aMenu addList: #(
		('find...'								textSearch)
		('show designations' 					showDesignationsOfObjects)
		('explain designations'					explainDesignations)
		"('look inside'							openInsideLook)"
		-
		('previous card' 						goToPreviousCardInStack)
		('next card' 							goToNextCardInStack)
		('first card' 							goToFirstCardOfStack)
		('last card' 								goToLastCardOfStack)
		('go to card...' 							goToCard)
		-
		('add a card of this background' 		insertCard)
		('add a card of background...'		 	insertCardOfBackground)
		('make a new background...' 			makeNewBackground)
		-
		('delete this card' 						deleteCard)
		-
		('move card to front of stack'			makeCurrentCardFirstInStack)
		('move card to back of stack'			makeCurrentCardLastInStack)
		('move card one position earlier'			moveCardOnePositionEarlier)
		('move card one position later'			moveCardOnePositionLater)
		-
		('scripts for this background'			browseCardClass)
		-
		('debug...'								offerStackDebugMenu)
		('bookish items...' 						offerBookishMenu)).

	aMenu addUpdating: #showingPageControlsString action: #toggleShowingOfPageControls.
	aMenu addUpdating: #showingFullScreenString action: #toggleFullScreen.

	aMenu popUpEvent: self world activeHand lastEvent in: self world


! !

!StackMorph methodsFor: 'card access' stamp: 'sw 3/5/2001 12:32'!
makeCurrentCardFirstInStack
	"Move the current card such that it becomes the first card in the stack"

	| aCard |
	aCard _ self currentCard.
	cards remove: aCard ifAbsent: [].
	cards addFirst: aCard.
	self currentPage flash! !

!StackMorph methodsFor: 'card access' stamp: 'sw 3/5/2001 12:32'!
makeCurrentCardLastInStack
	"Move the current card such that it becomes the last card in the stack"

	| aCard |
	aCard _ self currentCard.
	cards remove: aCard ifAbsent: [].
	cards addLast: aCard.
	self currentPage flash! !

!StackMorph methodsFor: 'card access' stamp: 'sw 3/5/2001 12:31'!
moveCardOnePositionEarlier
	"Move the current card such that its ordinal position is one fewer than it formerly was.  If the current card is already the first one one in the stack, then do nothing"

	| aCard aPosition |
	aCard _ self currentCard.
	aCard == cards first ifTrue: [^ self].
	aPosition _ cards indexOf: aCard.
	cards remove: aCard.
	cards add: aCard afterIndex: (aPosition - 2).
	self currentPage flash! !

!StackMorph methodsFor: 'card access' stamp: 'sw 3/5/2001 12:32'!
moveCardOnePositionLater
	"Move the current card such that its ordinal position is one greater than it formerly was.  If the current card is already the last one one in the stack, then do nothing"

	| aCard aPosition |
	aCard _ self currentCard.
	aCard == cards last ifTrue: [^ self].
	aPosition _ cards indexOf: aCard.
	cards remove: aCard.
	cards add: aCard afterIndex: aPosition.
	self currentPage flash! !

