'From Squeak 2.2 of Sept 23, 1998 on 2 November 1998 at 9:46:33 am'!
"Change Set:		sw_emptyCheck
Date:			2 November 1998
Author:			Scott Wallace

Fixes a long-standing bug in ParagraphEditor.lineSelectAndEmptyCheck:, which resulted, among other things, in the paste-buffer erroneously being cleared when you attempt to copy an empty selection.

Also, makes morphic text-editing consistent with mvc text-editing in that commands that are rejected because of an empty selection result in the same flashing of the pane"!


!ParagraphEditor methodsFor: 'menu messages' stamp: 'sw 11/2/1998 09:43'!
lineSelectAndEmptyCheck: returnBlock
	"If the current selection is an insertion point, expand it to be the entire current line; if after that's done the selection is still empty, then evaluate the returnBlock, which will typically consist of '[^ self]' in the caller -- check senders of this method to understand this."

	self selectLine.  "if current selection is an insertion point, then first select the entire line in which occurs before proceeding"
	startBlock = stopBlock ifTrue: [self flash.  ^ returnBlock value]! !


