'From Squeak3.1alpha of 28 February 2001 [latest update: #4004] on 10 May 2001 at 5:23:38 pm'!
"Change Set:		WnldDupFixes-ar
Date:			10 May 2001
Author:			Andreas Raab

Fixes some duplication issues in Wonderlands."!


!Hierarchical methodsFor: 'initialization' stamp: 'ar 5/10/2001 17:17'!
uniqueNameFrom: aString
	"Return a unique name for the string in the context of the receiver's name space"
	| index aName myNamespace |
	aName _ aString.
	myNamespace _ self getChildren asSet collect:[:each| each getName].
	(myNamespace includes: aName)
			ifFalse: [ ^ aName ].
	aName endsWithDigit ifTrue:[
		index _ aName findLast:[:ch| ch isDigit].
		aName _ (aName copyFrom: 1 to: index-1).
	].
	index _ 1.
	[ myNamespace includes: (aName , (index asString)) ]
		whileTrue: [ index _ index + 1 ].
	^ aName , (index asString).
! !


!Wonderland methodsFor: 'creating' stamp: 'ar 5/10/2001 17:18'!
duplicateActor: anActor
	"Creates a new actor without any geometry"
	| newActor |
	newActor _ anActor clone postCopy.
	anActor getParent == nil ifTrue:[
		newActor setName: (self uniqueNameFrom: newActor getName).
		myNamespace at: newActor getName put: newActor.
	] ifFalse:[
		newActor setName: (anActor getParent uniqueNameFrom: newActor getName).
		anActor getParent addChild: newActor.
		newActor setParent: anActor getParent.
	].

	scriptEditor updateActorBrowser.

	"Add an undo item to undo the creation of this object"
	myUndoStack push: (UndoAction new: [ newActor removeFromScene.
						 					scriptEditor updateActorBrowser. ]).

	^ newActor.
! !

!Wonderland methodsFor: 'creating' stamp: 'ar 5/10/2001 16:58'!
uniqueNameFrom: aString
	"If aName is unique to this wonderland's namespace, returns that name. Otherwise creates a unique variant and returns that."

	| index aName |
	aName _ self fixNameFrom: aString.
	(myNamespace includesKey: aName)
			ifFalse: [ ^ aName ].
	aName endsWithDigit ifTrue:[
		index _ aName findLast:[:ch| ch isDigit].
		aName _ (aName copyFrom: 1 to: index-1).
	].
	index _ 1.
	[ myNamespace includesKey: (aName , (index asString)) ]
		whileTrue: [ index _ index + 1 ].
	^ aName , (index asString).
! !


!WonderlandActor methodsFor: 'private' stamp: 'ar 5/10/2001 17:11'!
postCopy
	| props |
	myMesh _ myMesh shallowCopy.
	composite _ composite copy.
	scaleMatrix _ scaleMatrix copy.
	props _ myProperties.
	myProperties _ nil.
	props = nil ifFalse:[
		props keysAndValuesDo:[:k :v| self setProperty: k toValue: v]].! !

