'From Squeak3.1alpha of 28 February 2001 [latest update: #4160] on 20 June 2001 at 1:02:31 am'!
"Change Set:		chgListFix-sw
Date:			20 June 2001
Author:			Scott Wallace

Fixes a long-standing bug in morphic change-list handling, whereby a list selection that starts with a mouse down in the list-pane but not *over* any actual item would drop you into a debugger. Instead, the right thing is now done -- the selection status of the first actual item dragged over will determine whether this gesture will select or deselect items."!


!PluggableListMorphOfMany methodsFor: 'event handling' stamp: 'sw 6/20/2001 00:51'!
mouseMove: event
	"The mouse has moved, as characterized by the event provided.  Adjust the scrollbar, and alter the selection as appropriate"

	| index oldIndex oldVal aMorph |
	event position y < self top
		ifTrue:
			[scrollBar scrollUp: 1.
			aMorph _ self itemFromPoint: scroller topLeft + (1@1)]
		ifFalse:
			[event position y > self bottom
				ifTrue:
					[scrollBar scrollDown: 1.
					aMorph _ self itemFromPoint: scroller bottomLeft + (1@-1)]
				ifFalse:
					[aMorph _ self itemFromPoint: event position]].
	aMorph ifNil: [^ super mouseDown: event].

	model okToChange ifFalse: [^ self].  "No change if model is locked"

	index _ scroller submorphs indexOf: aMorph.
	index = 0 ifTrue: [^ self  "minimize chance of selecting with a pane border drag"].
	dragOnOrOff ifNil:  "Was not set at mouse down, which means the mouse must have gone down in an area where there was no list item"
		[dragOnOrOff _ (model listSelectionAt: index) not].

	"Set meaning for subsequent dragging of selection"
	oldIndex _ self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal _ model listSelectionAt: oldIndex].

	"Set or clear new primary selection (listIndex)"
	dragOnOrOff
		ifTrue: [self setSelectedMorph: aMorph]
		ifFalse: [self setSelectedMorph: nil].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [model listSelectionAt: oldIndex put: oldVal].
	model listSelectionAt: index put: (dragOnOrOff == true).
	aMorph changed! !

