'From Squeak3.2alpha of 3 October 2001 [latest update: #4441] on 25 October 2001 at 10:03:23 am'!
"Change Set:		RespectMinimumExtent-nk
Date:			25 October 2001
Author:			Ned Konz

Although Morph defines a minimumExtent: method and the SystemWindow reframing respects minimumExtent, it is ignored in SystemWindow>>extent:. This change set fixes that.

Currently the only sender of minimumExtent: is my ArchiveViewer, but it seems like other windows could/should use this property.
"!


!SystemWindow methodsFor: 'geometry' stamp: 'nk 10/25/2001 09:56'!
extent: aPoint 
	"Set the receiver's extent to value provided. Respect my minimumExtent."
	| newExtent |

	newExtent _ aPoint max: self minimumExtent.
	newExtent = self extent ifTrue: [ ^self ].

	isCollapsed
		ifTrue: [super extent: newExtent x @ (self labelHeight + 2)]
		ifFalse: [super extent: newExtent].
	labelArea ifNotNil:
		[self setStripeColorsFrom: self paneColorToUse.
		label fitContents; setWidth: (label width min: bounds width - self labelWidgetAllowance).
		label layoutFrame leftOffset: label width negated // 2].
	isCollapsed
		ifTrue: [collapsedFrame _ self bounds]
		ifFalse: [fullFrame _ self bounds]! !

