'From Squeak3.2alpha of 2 October 2001 [latest update: #4558] on 28 November 2001 at 9:52:26 pm'!
"Change Set:		MinesTweaks
Date:			26 November 2001
Author:			Dan Ingalls

Two changes specific to Mines, and one generic to Morphic that greatly speed up creation of the board.
"!

SimpleSwitchMorph subclass: #MinesTile
	instanceVariableNames: 'switchState disabled oldSwitchState isMine nearMines palette mineFlag '
	classVariableNames: 'PreferredColor '
	poolDictionaries: ''
	category: 'Morphic-Games'!

!Morph methodsFor: 'change reporting' stamp: 'di 11/28/2001 21:51'!
changed
	"Report that the area occupied by this morph should be redrawn."
	owner == nil ifTrue: [^ self].
	^ fullBounds 
		ifNil:	 [self invalidRect: self outerBounds]
		ifNotNil: [self invalidRect: fullBounds]! !


!MinesBoard methodsFor: 'initialization' stamp: 'di 11/26/2001 21:24'!
resetBoard

	gameStart _ false.
	gameOver _ false.
	[flashCount = 0] whileFalse: [self step].
	flashCount _ 0.
	tileCount _ 0.
	Collection initialize.  "randomize the Collection class"
	self purgeAllCommands.
	self submorphsDo: "set tiles to original state."
		[:m | m privateOwner: nil.  "Don't propagate all these changes..."
		m mineFlag: false.
		m disabled: false.
		m switchState: false.
		m isMine: false.
		m privateOwner: self].
	self changed  "Now note the change in bulk"! !


!MinesTile methodsFor: 'initialization' stamp: 'di 11/26/2001 21:27'!
preferredColor
		"PreferredColor _ nil  <-- to reset cache"
	PreferredColor ifNil:
		["This actually takes a while to compute..."
		PreferredColor _ Color gray lighter lighter lighter].
	^ PreferredColor! !

