'From Squeak 2.3 beta of Nov 25, 1998 on 7 December 1998 at 9:58:35 am'!
"Change Set:		fixesThree-sw
Date:			7 December 1998
Author:			Scott Wallace

Fixes the bug that dropped the user into a debugger when he hit the TRY button alongside a user-defined script in a Viewer.

Fixes the bug that dropped the user into a debugger when trying to put up a paint palette in a world that has a 'standard palette' designated which is not currently visible.

Fixes the bug that dropped the user into a debugger when requesting, in a Change Sorter, any of various commands for a class no longer present in the system."!


!ChangeSorter methodsFor: 'class list' stamp: 'sw 12/7/1998 09:43'!
selectedClass
	"Answer the currently-selected class.  If there is no selection, or if the selection refers to a class no longer extant, return nil"
	| c |
	^ currentClassName ifNotNil: [(c _ self selectedClassOrMetaClass)
		ifNotNil: [c theNonMetaClass]]! !


!Morph methodsFor: 'e-toy support' stamp: 'sw 12/7/1998 09:58'!
objectViewed
	^ (self outermostMorphThat: [:o | (o isKindOf: Viewer orOf: ScriptEditorMorph) or: [o isKindOf: PartsViewer]])  objectViewed! !


!SketchMorph methodsFor: 'menu' stamp: 'sw 12/5/1998 12:54'!
editDrawingIn: aPasteUpMorph forBackground: forBackground

	| w oldRotation bnds sketchEditor pal |
	w _ aPasteUpMorph world.
	w stopRunningAll; abandonAllHalos.
	w displayWorld.
	oldRotation _ rotationDegrees.
	forBackground
		ifTrue:
			[bnds _ aPasteUpMorph boundsInWorld]
		ifFalse:
			[bnds _ (self boundsInWorld expandBy: (60 @ 60)) intersect: self world bounds.
			bnds _ (aPasteUpMorph paintingBoundsAround: bnds center) merge: bnds].
	sketchEditor _ SketchEditorMorph new.
	forBackground ifTrue: [sketchEditor setProperty: #background toValue: true].
	w addMorphFront: sketchEditor.
	sketchEditor initializeFor: self inBounds: bnds pasteUpMorph: aPasteUpMorph.
		"self rotationDegrees: 0.  inside the init"
	self rotationDegrees: oldRotation.  "restore old rotation so that cancel leaves it right"
	sketchEditor
		afterNewPicDo: [:aForm :aRect |
			self form: aForm.
			self topRendererOrSelf position: aRect origin.
			self rotationStyle: sketchEditor rotationStyle.
			self setupAngle: sketchEditor forwardDirection.
			self rotationDegrees: sketchEditor forwardDirection.
			aPasteUpMorph playfield ifNotNil: "Show the right viewer"
				[self presenter drawingJustCompleted: self].
			forBackground ifTrue: [self goBehind]]  "shouldn't be necessary"
		ifNoBits: ["If no bits drawn.  Must keep old pic.  Can't have no picture"
			((pal _ aPasteUpMorph standardPalette) notNil and: [pal isInWorld]) ifTrue:
				[pal viewMorph: self]]! !


