'From Squeak3.3alpha of 12 January 2002 [latest update: #4798] on 12 March 2002 at 9:02:03 pm'!
"Change Set:		gZipContents-sw
Date:			12 March 2002
Author:			Scott Wallace

 Makes the window into which a gZipped file's decompressed contents are projected be a Workspace rather than a plain StringHolder, so that its window-menu will offer 'save contents to a file...', which is frequently useful here.
Do not automatically append '.text' to the specified filename when a workspace's contents are saved to a file -- instead, *suggest* a .text suffix (and not even that, in the case of a gZipped file being viewed decompressed,) but don't insist on it."!


!FileStream methodsFor: 'editing' stamp: 'sw 3/11/2002 22:42'!
viewGZipContents
	"View the contents of a gzipped file"

	| stringContents |
	self binary.
	stringContents _ self contentsOfEntireFile.
	Cursor wait showWhile: [stringContents _ (GZipReadStream on: stringContents) upToEnd].
	stringContents _ stringContents asString withSqueakLineEndings.

	Workspace new
		contents: stringContents;
		openLabel: 'Decompressed contents of: ', self localName! !


!GZipReadStream class methodsFor: 'fileIn/Out' stamp: 'sw 3/12/2002 19:34'!
viewContents: fullFileName
	"Open the decompressed contents of the .gz file with the given name.  This method is only required for the registering-file-list of Squeak 3.3a and beyond, but does no harm in an earlier system"

	(FileStream readOnlyFileNamed: fullFileName) ifNotNilDo:
		[:aStream | aStream viewGZipContents]! !


!ParagraphEditor methodsFor: 'menu messages' stamp: 'sw 3/12/2002 20:59'!
saveContentsInFile
	"Save the receiver's contents string to a file, prompting the user for a file-name.  Suggest a reasonable file-name."

	| fileName stringToSave parentWindow labelToUse suggestedName lastIndex |
	stringToSave _ paragraph text string.
	stringToSave size == 0 ifTrue: [^ self inform: 'nothing to save.'].
	parentWindow _ self model dependents
						detect: [:dep | dep isKindOf: SystemWindow orOf: StandardSystemView]
						ifNone: [nil].
	labelToUse _ parentWindow
		ifNil: 		['Untitled']
		ifNotNil: 	[parentWindow label].
	suggestedName _ nil.
	#(('Decompressed contents of: '		'.gz')) do:  "can add more here..."
		[:leaderTrailer |
			(labelToUse beginsWith: leaderTrailer first) ifTrue:
				[suggestedName _ labelToUse copyFrom: leaderTrailer first size + 1 to: labelToUse size.
				(labelToUse endsWith: leaderTrailer last)
					ifTrue:
						[suggestedName _ suggestedName copyFrom: 1 to: suggestedName size - leaderTrailer last size]
					ifFalse:
						[lastIndex _ suggestedName lastIndexOf: $. ifAbsent: [0].
						(lastIndex = 0 or: [lastIndex = 1]) ifFalse:
							[suggestedName _ suggestedName copyFrom: 1 to: lastIndex - 1]]]].

	suggestedName ifNil:
		[suggestedName _ labelToUse, '.text'].
			
	fileName _ FillInTheBlank request: 'File name?'
			initialAnswer: suggestedName.
	fileName isEmptyOrNil ifFalse:
		[(FileStream newFileNamed: fileName) nextPutAll: stringToSave; close]! !

