'From Squeak3.3alpha of 18 January 2002 [latest update: #4854] on 2 May 2002 at 11:05:12 am'!
"Change Set:		slidePref-sw
Date:			2 May 2002
Author:			Scott Wallace

Adds a preference, slideDismissalsToTrash, which governs whether the slide-to-trash animation should be used when a halo-dismissal results in something being put in the trash.  Formerly this behavior had been coupled with the #preserveTrash preference, but that raised a series of complaints from an unhappy user who wanted trash preserved but didn't want the animation."
Preferences addPreference: #slideDismissalsToTrash categories: #(morphic) default: true balloonHelp: 'If true, when a dismissal via the X-handle in a halo will result in the object being put into the Trash, the object will be animated to slide to a trash-can on the desktop.'.!


!Morph methodsFor: 'dropping/grabbing' stamp: 'sw 4/29/2002 23:39'!
slideToTrash: evt
	"Perhaps slide the receiver across the screen to a trash can and make it disappear into it.  In any case, remove the receiver from the screen."

	| aForm trash startPoint endPoint |
	((self renderedMorph == Utilities scrapsBook) or: [self renderedMorph isKindOf: TrashCanMorph]) ifTrue:
		[self delete.  ^ self].
	Preferences slideDismissalsToTrash ifTrue:
		[aForm _ self imageForm offset: 0@0.
		trash _ ActiveWorld
			findDeepSubmorphThat:
				[:aMorph | (aMorph isKindOf: TrashCanMorph) and:
					[aMorph topRendererOrSelf owner == ActiveWorld]]
			ifAbsent:
				[trash _ TrashCanMorph new.
				trash position: ActiveWorld bottomLeft - (0 @ (trash extent y + 26)).
				trash openInWorld.
				trash].
		endPoint _ trash fullBoundsInWorld center - (self topRendererOrSelf extent // 2).
		startPoint _ self topRendererOrSelf topLeft].
	self delete.
	ActiveWorld displayWorld.
	Preferences slideDismissalsToTrash ifTrue:
		[aForm slideFrom: startPoint to: endPoint nSteps: 12 delay: 15].
	Utilities addToTrash: self! !

