'From Squeak3.3alpha of 12 January 2002 [latest update: #4778] on 26 February 2002 at 11:51:43 pm'!
"Change Set:		minorTweaks-sw
Date:			26 February 2002
Author:			Scott Wallace

Published to 3.3a as 4780minorTweaks-sw.cs.

 Provides hook for suppressing unwanted file-list buttons that take up more space than they're worth (the items still are visible in the menu, of course.)
 Gets newly-launched uniclasses classified as per modules.
 Gives names to single-preference buttons that reflect the preference they represent -- based on a suggestion from Lantz Rowland."!


!FileList methodsFor: 'initialization' stamp: 'sw 2/26/2002 00:35'!
buttonSelectorsToSuppress
	"Answer a list of action selectors whose corresponding services we would prefer *not* to have appear in the filelist's button pane; this can be hand-jimmied to suit personal taste."

	^ #(removeLineFeeds:)! !

!FileList methodsFor: 'initialization' stamp: 'sw 2/26/2002 00:37'!
dynamicButtonServices
	"Answer services for buttons that may come and go in the button pane, depending on selection"

	^ fileName isEmptyOrNil
		ifTrue:
			[#()]
		ifFalse:
			[ | toReject |
				toReject _ self buttonSelectorsToSuppress.
				(self itemsForFile: self fullName) reject:
					[:svc | toReject includes: svc selector]]! !


!Object class methodsFor: 'instance creation' stamp: 'sw 2/5/2002 21:09'!
categoryForUniclasses
	"Answer the category into which to place unique-class instances"

	^ 'EToy-UserObjects'! !


!Preference methodsFor: 'button' stamp: 'sw 2/24/2002 19:09'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	"Return a button that controls the setting of prefSymbol.  It will keep up to date even if the preference value is changed in a different place"

	| outerButton aButton str miniWrapper |
	
	outerButton _ AlignmentMorph newRow height: 24.
	outerButton color:  (aColor ifNil: [Color r: 0.645 g: 1.0 b: 1.0]).
	outerButton hResizing: (aPreferencesPanel ifNil: [#shrinkWrap] ifNotNil: [#spaceFill]).
	outerButton vResizing: #shrinkWrap.
	outerButton addMorph: (aButton _ UpdatingThreePhaseButtonMorph checkBox).
	aButton
		target: self;
		actionSelector: #togglePreferenceValue;
		getSelector: #preferenceValue.

	outerButton addTransparentSpacerOfSize: (2 @ 0).
	str _ StringMorph contents: name font: (StrikeFont familyName: 'NewYork' size: 12).

	localToProject ifTrue:
		[str emphasis: 1].

	miniWrapper _ AlignmentMorph newRow hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	miniWrapper beTransparent addMorphBack: str lock.
	aPreferencesPanel
		ifNotNil:  "We're in a Preferences panel"
			[miniWrapper on: #mouseDown send: #offerPreferenceNameMenu:with:in: to: self withValue: aPreferencesPanel.
			miniWrapper on: #mouseEnter send: #menuButtonMouseEnter: to: miniWrapper.
			miniWrapper on: #mouseLeave send: #menuButtonMouseLeave: to: miniWrapper.
			miniWrapper setBalloonText: 'Click here for a menu of options regarding this preference.  Click on the checkbox to the left to toggle the setting of this preference']

		ifNil:  "We're a naked button, not in a panel"
			[miniWrapper setBalloonText: helpString; setProperty: #balloonTarget toValue: aButton].

	outerButton addMorphBack: miniWrapper.
	outerButton setNameTo: name.

	aButton setBalloonText: helpString.

	^ outerButton

	"(Preferences preferenceAt: #balloonHelpEnabled) tearOffButton"! !

