'From Squeak3.4alpha of ''11 November 2002'' [latest update: #5125] on 21 November 2002 at 3:31:36 pm'!
"Change Set:		fileListMPEG-bkv.cs
Date:			21 November 2002
Author:			Brent Vukmer

This changeset registers the MPEGMoviePlayerMorph with the FileList.  MP3s etc. can now be played from the FileList.  Ned Konz is the man behind the music -- he provided several necessary fixes/enhancements.  Thanks, Ned!!"!


!MPEGMoviePlayerMorph methodsFor: '*Tools-FileList-accessing' stamp: 'bkv 11/21/2002 11:24'!
moviePlayer 
    "Enables this Morph to offer services with the FileList."
     ^moviePlayer
! !

!MPEGMoviePlayerMorph methodsFor: 'private' stamp: 'nk 11/21/2002 10:32'!
addQuitButton
	self submorphs second
		addMorphFront: (Morph new extent: 4@1; color: Color transparent);
		addMorphFront: ( SimpleButtonMorph new
			target: self;
			label: 'Quit';
			actionSelector: #quit;
			color: (Color gray: 0.8);  "old color"
			fillStyle: self buttonFillStyle;
			borderWidth: 0;
			borderColor: #raised)
! !

!MPEGMoviePlayerMorph methodsFor: 'private' stamp: 'nk 11/21/2002 10:41'!
quit
	moviePlayer stopPlaying.
	self delete.! !


!MPEGMoviePlayerMorph class methodsFor: '*Tools-FileList-registering' stamp: 'bkv 11/21/2002 11:18'!
fileReaderServicesForFile: fullName suffix: suffix 

	|  selectedServices |
	selectedServices _ OrderedCollection new.
	((MPEGPlayer registeredVideoFileSuffixes includes: suffix ) or: [ MPEGPlayer registeredAudioFileSuffixes includes: suffix ] )
		ifTrue: [ ^self services ].
	^ selectedServices! !

!MPEGMoviePlayerMorph class methodsFor: '*Tools-FileList-registering' stamp: 'bkv 11/21/2002 11:19'!
initialize 
    "MPEGMoviePlayerMorph initialize."

    FileList registerFileReader: self.! !

!MPEGMoviePlayerMorph class methodsFor: '*Tools-FileList-registering' stamp: 'nk 11/21/2002 10:22'!
openOn: aFileName

     | wrapper |
     
     wrapper _ self new initialize addQuitButton.
     wrapper moviePlayer openFileNamed: aFileName. 
     ^wrapper! !

!MPEGMoviePlayerMorph class methodsFor: '*Tools-FileList-registering' stamp: 'nk 11/21/2002 10:19'!
playFile: aFileName

     | wrapper |
     
     wrapper _ self openOn: aFileName.
     wrapper moviePlayer startPlaying. 
     "wrapper openInWindow."
	wrapper openInWorld.
     ^wrapper! !

!MPEGMoviePlayerMorph class methodsFor: '*Tools-FileList-registering' stamp: 'bkv 11/21/2002 11:47'!
serviceOpenInMPEGPlayer
	"Answer a service for opening in a MPEG player"

	^ SimpleServiceEntry
		provider: self
		label: 'open in MPEG player'
		selector: #openOn: 
		description: 'open in MPEG player'
		buttonLabel: 'open'! !

!MPEGMoviePlayerMorph class methodsFor: '*Tools-FileList-registering' stamp: 'bkv 11/21/2002 11:47'!
servicePlayInMPEGPlayer
	"Answer a service for opening in a MPEG player"

	^ SimpleServiceEntry
		provider: self
		label: 'play in MPEG player'
		selector: #playFile: 
		description: 'play in MPEG player'
		buttonLabel: 'play'! !

!MPEGMoviePlayerMorph class methodsFor: '*Tools-FileList-registering' stamp: 'bkv 11/21/2002 12:02'!
services 

     ^OrderedCollection with: self servicePlayInMPEGPlayer
! !


!MPEGPlayer class methodsFor: '*Tools-FileList-file suffixes' stamp: 'bkv 11/21/2002 15:28'!
registeredAudioFileSuffixes
    "Answer the file extensions for which MPEGPlayer registers audio services with FileList."
     "MPEGPlayer registeredAudioFileSuffixes"

     ^{ 'mp3'.  }

	! !

!MPEGPlayer class methodsFor: '*Tools-FileList-file suffixes' stamp: 'bkv 11/21/2002 11:14'!
registeredVideoFileSuffixes
    "Answer the file extensions for which MPEGPlayer registers video services with FileList."
     "MPEGPlayer registeredVideoFileSuffixes"

     ^{ 'mpg'. 'mpeg'. 'jmv'. }

	! !

MPEGPlayer class removeSelector: #fileReaderServicesForFile:suffix:!
MPEGPlayer class removeSelector: #initialize!
MPEGPlayer class removeSelector: #registeredFileSuffixes!
MPEGPlayer class removeSelector: #serviceOpenInMPEGPlayer!
MPEGPlayer class removeSelector: #services!

!MPEGPlayer class reorganize!
('*Tools-FileList-file suffixes' registeredAudioFileSuffixes registeredVideoFileSuffixes)
('instance creation' playFile: playFile:onForm: playFile:onMorph:)
!

MPEGMoviePlayerMorph initialize!
MPEGMoviePlayerMorph removeSelector: #moviePlayer:!

!MPEGMoviePlayerMorph reorganize!
('*Tools-FileList-accessing' moviePlayer)
('initialization' initialize)
('drawing' drawOn:)
('stepping' step stepTime)
('private' addButtonRow addPositionSlider addQuitButton addVolumeSlider buttonFillStyle buttonName:action: moviePlayerFillStyle quit)
('menu' invokeMenu)
!

