'From Squeak3.4alpha of ''11 November 2002'' [latest update: #5134] on 30 November 2002 at 3:34:12 pm'!
"Change Set:		MoreFileFixes-nk
Date:			30 November 2002
Author:			Ned Konz

This is a further attempt to get FileDirectory>>exists to work right across platforms.

Unfortunately, this doesn't pass the FileDirectoryTests on the 3.2-6 Unix VM or the 3.4.0Beta Mac VM. It does on the Windows VM, and I've also posted changes to the Unix VM to make it work there.

However, this code should be the correct solution to the problem.

"!


!FileDirectory methodsFor: 'testing' stamp: 'nk 11/30/2002 14:06'!
exists
"Answer whether the directory exists"

	| result |
	result _ self primLookupEntryIn: pathName index: 1.
	^ result ~= #badDirectoryPath! !


!FileList methodsFor: 'file list menu' stamp: 'nk 11/30/2002 14:53'!
itemsForFile: fullName
	"Answer a list of services appropriate for a file of the given full name"

	| services suffix |
	suffix _ self suffixOf: fullName.
	services _ OrderedCollection new.
	self registeredFileReaderClasses do: [:reader |
		reader ifNotNil: [services addAll: (reader fileReaderServicesForFile: fullName suffix: suffix)]].
	^ services, (self myServicesForFile: fullName suffix: suffix)! !

!FileList methodsFor: 'file list menu' stamp: 'nk 11/30/2002 14:52'!
suffixOf: aName
	"Answer the file extension of the given file"
	^ aName
		ifNil:
			['']
		ifNotNil:
			[(FileDirectory extensionFor: aName) asLowercase]! !

!FileList methodsFor: 'file list menu' stamp: 'nk 11/30/2002 14:53'!
suffixOfSelectedFile
	"Answer the file extension of the receiver's selected file"
	^ self suffixOf: self fullName.! !


!FileListTest methodsFor: 'test' stamp: 'nk 11/30/2002 14:55'!
testServicesForFileEnding
	"(self selector: #testServicesForFileEnding) debug"

	self assert: (((FileList new directory: FileDirectory default; yourself) itemsForFile: 'aaa.kkk') anySatisfy: [ :ea | self checkIsServiceIsFromDummyTool: ea ]).
! !

