'From Squeak 2.3 of January 14, 1999 on 10 February 1999 at 9:30:23 pm'!
"Change Set:		logStartupFix-sw
Date:			10 February 1999
Author:			Scott Wallace

Fixes a bug in today's earlier logStartup update -- the pending stamp was not being logged upon the first method submission, but rather only on the first expression evaluation."!


!CompiledMethod methodsFor: 'source code management' stamp: 'sw 2/10/1999 21:27'!
putSource: sourceStr fromParseNode: methodNode inFile: fileIndex withPreamble: preambleBlock
	"Store the source code for the receiver on an external file.
	If no sources are available, i.e., SourceFile is nil, then store
	temp names for decompilation at the end of the method.
	If the fileIndex is 1, print on *.sources;  if it is 2, print on *.changes,
	in each case, storing a 4-byte source code pointer at the method end."
	| file remoteString startupStamp |
	(SourceFiles == nil or: [(file _ SourceFiles at: fileIndex) == nil]) ifTrue:
		[^ self become: (self copyWithTempNames: methodNode tempNames)].

	file setToEnd.
	(startupStamp _  Smalltalk at: #StartupStamp ifAbsent: [nil]) ifNotNil:
		[file nextChunkPut: startupStamp asString; cr.
		Smalltalk removeKey: #StartupStamp].

	preambleBlock value: file.  "Write the preamble"
	remoteString _ RemoteString newString: sourceStr
						onFileNumber: fileIndex toFile: file.
	file nextChunkPut: ' '; flush.
	self setSourcePosition: remoteString position inFile: fileIndex! !


