'From Squeak 2.3 of January 14, 1999 on 25 February 1999 at 4:44:44 pm'!
"Change Set:		clock-sw
Date:			25 February 1999
Author:			Scott Wallace

Adds choice of showing-seconds or not-showing-seconds to ClockMorph.  Along the way, adds a variant Time method that supports both choices."!

StringMorph subclass: #ClockMorph
	instanceVariableNames: 'showSeconds '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Demo'!

!ClockMorph methodsFor: 'all' stamp: 'sw 2/24/1999 12:51'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Note minor loose end here -- if the menu is persistent, then the wording will be wrong half the time"
	| item |
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	item _ showSeconds == true
		ifTrue:	['stop showing seconds']
		ifFalse: ['start showing seconds'].
	aCustomMenu add: item target: self action: #toggleShowingSeconds
! !

!ClockMorph methodsFor: 'all' stamp: 'sw 2/17/1999 14:39'!
initialize
	super initialize.
	showSeconds _ true.
	self step! !

!ClockMorph methodsFor: 'all' stamp: 'sw 2/17/1999 14:39'!
showSeconds: aBoolean
	showSeconds _ aBoolean! !

!ClockMorph methodsFor: 'all' stamp: 'sw 2/17/1999 14:49'!
step
	| time |
	super step.
	time _ String streamContents:
		[:aStrm | Time now print24: false showSeconds: (showSeconds == true) on: aStrm].

	self contents: time			! !

!ClockMorph methodsFor: 'all' stamp: 'sw 2/17/1999 14:53'!
toggleShowingSeconds
	showSeconds _ (showSeconds == true) not
! !


!Time methodsFor: 'printing' stamp: 'sw 2/17/1999 14:48'!
print24: hr24 showSeconds: showSeconds on: aStream 
	"Format is 'hh:mm:ss' or 'h:mm:ss am'  or, if showSeconds is false, 'hh:mm' or 'h:mm am'"

	hr24
		ifTrue:
			[hours < 10 ifTrue: [aStream nextPutAll: '0'].
			hours printOn: aStream]
		ifFalse:
			[hours > 12
				ifTrue: [hours - 12 printOn: aStream]
				ifFalse: [hours < 1
					ifTrue: [12 printOn: aStream]
					ifFalse: [hours printOn: aStream]]].

	aStream nextPutAll: (minutes < 10 ifTrue: [':0'] ifFalse: [':']).
	minutes printOn: aStream.

	showSeconds ifTrue:
		[aStream nextPutAll: (seconds < 10 ifTrue: [':0'] ifFalse: [':']).
		seconds printOn: aStream].

	hr24 ifFalse:
		[aStream nextPutAll: (hours < 12 ifTrue: [' am'] ifFalse: [' pm'])]! !


