'From Squeak 2.3 beta of Nov 25, 1998 on 2 March 1999 at 10:48 am'!

!HandMorph methodsFor: 'grabbing/dropping' stamp: 'tk 2/28/1999 22:26'!
grabMorphFromMenu: m
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner) without changing its position. This is used to pick up a morph under the hand's current position, versus attachMorph: which is used to pick up a morph that may not be near this hand."
	| delta |
	(m owner isKindOf: DropShadowMorph)
		ifTrue: [^ self grabMorphFromMenu: m owner].
	m aboutToBeGrabbedBy: self.
	delta _ m position - menuTargetOffset.
	gridOn ifTrue: [delta _ delta grid: grid].
	m position: self position + delta.
	self addMorphBack: m.! !

!HandMorph methodsFor: 'world menu commands' stamp: 'tk 3/1/1999 09:57'!
copyToPasteBuffer
	"Save this morph in the paste buffer. This is mostly useful for copying morphs between projects."

	argument isMorph
		ifTrue: [Cursor wait showWhile: 
					[argument okayToDuplicate ifTrue:
						[PasteBuffer _ argument topRendererOrSelf veryDeepCopy.
						PasteBuffer aboutToBeGrabbedBy: self]]]
		ifFalse: [PasteBuffer _ nil].

! !

!HandMorph methodsFor: 'world menu commands' stamp: 'tk 3/1/1999 11:02'!
pasteMorph

	| aPastee |
	PasteBuffer ifNil: [^ self inform: 'Nothing to paste.'].
	self attachMorph: (aPastee _ self objectToPaste).
	aPastee align: aPastee center with: self position.
	aPastee player ifNotNil: [aPastee player startRunning]
! !


MatrixTransformMorph removeSelector: #position:!
