'From Squeak 2.3 of January 14, 1999 on 5 April 1999 at 11:51:10 am'!
"Change Set:		WonderlandFixes-ar
Date:			5 April 1999
Author:			Andreas Raab

A couple of fixes for Wonderland (including the flicker-free updates)."!


!B3DSqueakFormRasterizer methodsFor: 'initialize' stamp: 'ar 4/5/1999 11:48'!
initialize
	super initialize.
	self on: Display.
	dotForm _ Form extent: 3@3 depth: 32.
	dotForm fillBlack.
	lineForm _ Form extent: 1@1 depth: 32.
	lineForm fillBlack.! !


!B3DVertexBuffer methodsFor: 'primitives' stamp: 'ar 4/5/1999 11:48'!
primLoadIndexArrayInto: dstArray startingAt: dstStart from: idxArray count: count max: maxValue offset: vtxOffset
	"Primitive. Load the given index array into the receiver.
	NOTE: dstStart is a zero-based index."
	| idx |
	<primitive:'b3dLoadIndexArray' module:'Squeak3D'>
	"self flag: #b3dDebug.	self primitiveFailed."
	1 to: count do:[:i|
		idx _ idxArray basicAt: i.
		(idx < 1 or:[idx > maxValue]) ifTrue:[^self error:'Index out of range'].
		dstArray at: dstStart + i put: idx + vtxOffset.
	].
	^count! !

!B3DVertexBuffer methodsFor: 'primitives' stamp: 'ar 4/5/1999 11:48'!
primLoadVB: dstArray startingAt: dstStart vertices: vertices normals: normals colors: colors texCoords: texCoords count: count default: defaultValues
	| hasNormals hasColors hasTexCoords pVtx defaultNormal defaultColor defaultTexCoords |
	<primitive:'b3dLoadVertexBuffer' module:'Squeak3D'>
	"self flag: #b3dDebug.	self primitiveFailed."
	defaultNormal _ defaultValues normal.
	defaultColor _ defaultValues color.
	defaultTexCoords _ defaultValues texCoords.
	hasNormals _ normals notNil.
	hasColors _ colors notNil.
	hasTexCoords _ texCoords notNil.
	1 to: count do:[:i|
		pVtx _ dstArray at: dstStart + i.
		pVtx position: (vertices at: i).
		pVtx normal: (hasNormals ifTrue:[normals at: i] ifFalse:[defaultNormal]).
		pVtx color: (hasColors ifTrue:[colors at: i] ifFalse:[defaultColor]).
		pVtx texCoords: (hasTexCoords ifTrue:[texCoords at: i] ifFalse:[defaultTexCoords]).
		dstArray at: dstStart + i put: pVtx.
	].
	^count! !


!B3DVertexShader methodsFor: 'shading' stamp: 'ar 4/5/1999 11:49'!
processVertexBuffer: vb
	| colors emissionPart |
	colors _ B3DColor4Array new: vb vertexCount.
	"Load initial colors (e.g., emission part)"
	vb trackEmissionColor ifFalse:[
		emissionPart _ material emission.
		1 to: vb vertexCount do:[:i| colors at: i put: emissionPart].
	] ifTrue:[
		1 to: vb vertexCount do:[:i| colors at: i put: (vb primitiveVertexAt: i) b3dColor].
	].
	lights do:[:light|
		light shadeVertexBuffer: vb with: material into: colors.
	].
	colors clampAllFrom: 0.0 to: 1.0.
	vb vertexArray upTo: vb vertexCount doWithIndex:[:vtx :i| vtx color: (colors at: i)].
! !


!OSMesaRasterizer methodsFor: 'initialize' stamp: 'ar 4/5/1999 11:47'!
finish
	Smalltalk isMorphic ifFalse:[
		"If we're using this guy from MVC we have to force the changes on screen."
		self form == Display ifTrue:[self form forceToScreen: viewport].
	].! !


