'From Squeak 2.3 of January 14, 1999 on 12 April 1999 at 11:53:44 pm'!
"Change Set:		DependentsTweaks
Date:			12 April 1999
Author:			Dan Ingalls

Fixes a bug that caused FillInTheBlankMorphs not to be reclaimed from the global dependents dictionary.  Also extends the reclaimDependents utility method to current SystemWindow usage.
"!


!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'di 4/12/1999 16:19'!
delete

	self breakDependents.
	^ super delete! !


!SystemDictionary methodsFor: 'housekeeping' stamp: 'di 4/12/1999 16:55'!
reclaimDependents		"Smalltalk reclaimDependents"
	"Reclaim unused entries in DependentsFields (DF)..."
	"NOTE:  if <object>addDependent: is ever used to add something
		other than a view, this process will fail to reinstate that
		thing after clearing out DependentsFields.  DF was only
		intended to be used as part of the MVC architecture."
	Object classPool at: #DependentsFields  "Remove all entries from DF"
				put: IdentityDictionary new.
	Smalltalk garbageCollect.  "If that was the only reference, they will go away"
	"Now if any views of non-models remain,
		they should be reinstated as dependent views..."
	View allSubInstancesDo:
		[:v | (v model==nil or: [v model isKindOf: Model])
				ifFalse: [v model addDependent: v]].
	SystemWindow allInstancesDo:
		[:v | (v model==nil or: [v model isKindOf: Model])
				ifFalse: [v model addDependent: v]].
! !


