'From Squeak 2.3 of January 14, 1999 on 19 April 1999 at 6:08:01 pm'!
"Change Set:		wnld-events-jsp
Date:			19 April 1999
Author:			Jeff Pierce

Adds event handling to Wonderlands.  Actors can respond to left and right mouse up/down/click events, as well as key presses."!

Object subclass: #WonderlandEvent
	instanceVariableNames: 'actor camera cursorPoint cursorDelta key morph '
	classVariableNames: ''
	poolDictionaries: 'WonderlandConstants '
	category: 'Wonderland-Misc'!
Object subclass: #WonderlandReaction
	instanceVariableNames: 'reaction '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wonderland-Misc'!

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:54'!
getActor

	^ actor.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:54'!
getCamera

	^ camera.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:54'!
getCameraMorph
	"Return the camera window the user clicked in"

	^ morph.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 14:37'!
getCursorDelta

	^ cursorDelta.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:55'!
getCursorPoint

	^ cursorPoint.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:56'!
getKey

	^ key.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:54'!
setActor: anActor

	actor _ anActor.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:53'!
setCamera: aCamera

	camera _ aCamera.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:53'!
setCameraMorph: aMorph
	"Set the camera window the user clicked in"

	morph _ aMorph.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 14:37'!
setCursorDelta: aPoint

	cursorDelta _ aPoint.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:55'!
setCursorPoint: aPoint

	cursorPoint _ aPoint.
! !

!WonderlandEvent methodsFor: 'accessing' stamp: 'jsp 4/19/1999 13:56'!
setKey: aKey

	key _ aKey.
! !


!WonderlandEvent class methodsFor: 'class initialization' stamp: 'jsp 4/19/1999 17:47'!
initialize
	"Add some new constants to the WonderlandConstants shared pool"

	WonderlandConstants at: 'leftMouseDown' put: 'leftMouseDown'.
	WonderlandConstants at: 'leftMouseUp' put: 'leftMouseUp'.
	WonderlandConstants at: 'rightMouseDown' put: 'rightMouseDown'.
	WonderlandConstants at: 'rightMouseUp' put: 'rightMouseUp'.
	WonderlandConstants at: 'leftMouseClick' put: 'leftMouseUp'.
	WonderlandConstants at: 'rightMouseClick' put: 'rightMouseUp'.
	WonderlandConstants at: 'mouseMove' put: 'mouseMove'.
	WonderlandConstants at: 'keyPress' put: 'keyPress'.
	
 ! !


!WonderlandReaction methodsFor: 'initialization' stamp: 'jsp 4/19/1999 13:15'!
initializeWith: aReaction
	"Set the wrapped reaction"

	reaction _ aReaction.
! !

!WonderlandReaction methodsFor: 'react' stamp: 'jsp 4/19/1999 14:20'!
reactTo: event
	"Activate the reaction with the event."

	reaction value: event.
! !


!WonderlandReaction class methodsFor: 'instance creation' stamp: 'jsp 4/19/1999 14:21'!
new: aReaction
	"Create a new WonderlandReaction instance.  This instance basically wraps a block that specifies what the given object should do"

	^ self new initializeWith: aReaction.
! !


WonderlandEvent initialize!
